' This is a quad+ purpose class :(  Hate that.
' 1) Scans/Get/Count declarations
' 2) Returns line x/line count
' 3) Returns declaration counts/indexes
' 4) Returns reference counts/indexes
' + other stuff.  Thinking of taking the stuffing out of this class.

' For dotted references
' 1st reference tParent is routine
' 2nd-nth dotted reference is last var
'
' obj.First( wrk.Index ).Name
' obj tParent = Routine index
' First = obj index
' wrk = Routine index
' Index = wrk index
' Name = First index

' Declarations are designed to stack up.  i.e. you can scan multiple files without clearing.
' what's important is if you find a declaration in a particular file, you need to make sure
' that file is loaded before calling many of the routines.
'
' I'm thought about taking the routines out, but then I end up duplicating a lot of code
' such as all the token routines.  In the long run I probabbly need to break this into
' three classes.  A source navigation class.  A declaration scanner.  And a class that
' does things with declarations (maybe even just routines)

Sub NewDeclarations( obj As iDeclarations )
	obj = Class "cDeclarations"
End Sub

Class cDeclarations
	Instance count_ As Long
	Instance size_ As Long
	Instance decl_() As TDecl
	Instance blank_ As TDecl
	Instance names_ As iStringDeclMap

	Instance startLine_ As Long
	Instance startToken_ As Long

	Instance sf_ As iSourceFile
	Instance row_ As Long
	Instance tkn_ As Long
	Instance fileNumber_ As Long

	Class Method Create()
		Call NewStringDeclMap( names_, 50000, 1000 )
	End Method

	Interface iDeclarations
		Inherit IUnknown

		Method GetInterfaceDeclaration( ByVal index As Long, constants As String ) As String
			Method = Me.cmGetInterfaceDeclaration( index, constants )
		End Method

		Method GetDLLDeclaration( libName As String, exportList As String, routines As String, interfaces As String, constants As String, enums As String, types As String, unions As String )
			Me.cmGetDLLDeclaration( libName, exportList, routines, interfaces, constants, enums, types, unions )
		End Method

		Method GetSLLDeclaration( exportList As String, routines As String, interfaces As String, constants As String, enums As String, types As String, unions As String )
			Me.cmGetSLLDeclaration( exportList, routines, interfaces, constants, enums, types, unions )
		End Method

		Method FindName( ByVal start As Long, value As String, ByVal declType As Long ) As Long
			Method = Me.cmFindName( start, value, declType )
		End Method

		Method GetInterfaceRoutines( ByVal index As Long ) As String
			Method = Me.cmGetInterfaceRoutines( index )
		End Method

		Method GetInterfaceStub( ByVal index As Long ) As String
			Method = Me.cmGetInterfaceStub( index )
		End Method

		Method GetInterfaceClasses( interfaceName As String ) As String
			Method = Me.cmGetInterfaceClasses( interfaceName )
		End Method

		Method GetDefinition( ByVal index As Long ) As String
			Method = Me.cmGetDefinition( index )
		End Method

		Method StandardizeExportAliases( exportList As String )
			Me.cmStandardizeExportAliases( exportList )
		End Method

		Method AddDebugAliases()
			Me.cmAddDebugAliases()
		End Method

		Method RemoveAliases()
			Me.cmRemoveAliases()
		End Method

		Method GetNames( declType As Long, Optional fileNumber As Long ) As String
			If IsMissing( fileNumber ) Then
				Method = Me.cmGetNames( declType )
			Else
				Method = Me.cmGetNames( declType, fileNumber )
			End If
		End Method

		Method GetSignature( ByVal index As Long ) As String
			Method = Me.cmGetSignature( index )
		End Method

		Method GetClassOutline( ByVal index As Long ) As String
			Method = Me.cmGetClassOutline( index )
		End Method

		Method GetClassInterfaces( ByVal index As Long ) As String
			Method = Me.cmGetClassInterfaces( index )
		End Method

		Method GetInstanceVariables( ByVal index As Long ) As String
			Method = Me.cmGetInstanceVariables( index )
		End Method

		Method GetClassMethods( ByVal index As Long ) As String
			Method = Me.cmGetClassMethods( index )
		End Method

		'========================================
		Property Get LineCount() As Long
			Property = sf_.Count
		End Property

		Property Get Line( ByVal lineIndex As Long ) As String
			If lineIndex<0 Or lineIndex>=sf_.Count Then Exit Property
			Property = sf_.Line( lineIndex )
		End Property

		Property Get Name( ByVal nameIndex As Long ) As String
			If nameIndex>=0 And nameIndex<names_.Count Then
				' key at index
				Property = names_.Key( nameIndex )
			End If
		End Property

		Property Get NameCount() As Long
			' # of names
			Property = names_.Count
		End Property

		Property Get Count() As Long
			' # of declarations and references
			Property = count_
		End Property

		Property Get Index( pKey As String ) As Long
			' index of key
			Property = names_.Index( pKey )
		End Property

		Property Get DeclarationCount( ByVal nameIndex As Long ) As Long
			' # of declarations for name at index
			Property = names_.DeclarationCount( nameIndex )
		End Property
		Property Get ReferenceCount( ByVal nameIndex As Long ) As Long
			' # of references for name at index
			Property = names_.ReferenceCount( nameIndex )
		End Property

		Property Get Declaration( ByVal nameIndex As Long, ByVal declIndex As Long ) As Long
			' Get the Item number for the declIndex entry of the name at index
			Property = names_.Declaration( nameIndex, declIndex )
		End Property
		Property Get Reference( ByVal nameIndex As Long, ByVal refIndex As Long ) As Long
			' Get the reference index for the declIndex entry of the name at index
			Property = names_.Reference( nameIndex, refIndex )
		End Property

		Property Get Item( index As Long ) As TDecl
			If index>=0 And index<count_ Then
				Property = decl_( index )
			End If
		End Property

		Method Clear()
			If count_ Then Erase decl_
			count_ = 0
			size_ = 0
			names_.Clear
		End Method

		Property Get SourceFile() As iSourceFile
			Property = sf_
		End Property
		Property Set SourceFile( value As iSourceFile )
			If IsFalse IsInterface( value, iSourceFile) Then Exit Property
			sf_ = value
		End Property

		Property Get FileNumber() As Long
			Property = fileNumber_
		End Property
		Property Set FileNumber( ByVal value As Long )
			fileNumber_ = value
		End Property

		' ScanTop is designed to work against strings, but can be given "indexes" to the strings, such as file numbers.
		' Does not process #Includes.  A top level declare shouldn't be able to span files in the middle.
		Method Scan( sf As iSourceFile, ByVal fileNumber As Long, Optional ByVal pClear As Long )
			#Debug Code Off
			Local p, p2 As Byte Ptr
			Local c, c2 As Long
			Local tknTyp, tknTyp2 As Long

			If IsFalse IsInterface( sf, iSourceFile ) Then Exit Method

			sf_ = sf
			fileNumber_ = fileNumber
			If pClear Then Me.Clear()

			row_ = 0: ' Row
			tkn_ = -1: ' Token
			If sf_.Count = 0 Then Exit Method: ' Done!
			tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
			Do While row_ < sf_.Count
				If Not Me.NextStatementToken( p, c, tknTyp ) Then Iterate Loop
				startLine_ = row_
				startToken_ = tkn_
				Select Case Const @p
					Case %cDollar, %cPercent
						If tknTyp=%TokenTypes.eConstant Then
							Call Me.ProcessConstant( p )
						Else
							GoTo NotInitialToken
						End If
					Case 65, 97 ' a
						If PtrStrICmp( p, "asmdata")=0 Then
							Call Me.ProcessShort( %DeclarationTypes.eAsmdata, "asmdata" )
						Else
							GoTo NotInitialToken
						End If
					Case 67, 99 ' c
						If PtrStrICmp( p, "callback")=0 Then
							Call Me.ProcessRoutine( p, %DeclarationTypes.eFunction, "function", 0 )
						ElseIf PtrStrICmp( p, "class" )=0 Then
							Call Me.ProcessClass()
						Else
							GoTo NotInitialToken
						End If
					Case 68, 100 ' d
						If PtrStrICmp( p, "declare" )=0 Then
							If Not Me.NextStatementToken( p, c, tknTyp ) Then Iterate Loop
							Select Case Const @p
								Case 67, 99 ' c
									If PtrStrICmp( p, "callback")=0 Then
										Call Me.ProcessRoutine( p, %DeclarationTypes.eFunction, "function", -1 )
									Else
										GoTo NotInitialToken
									End If
								Case 70, 102 ' f
									If PtrStrICmp( p, "function" )=0 Then
										Call Me.ProcessRoutine( p, %DeclarationTypes.eFunction, "function", -1 )
									Else
										GoTo NotInitialToken
									End If
								Case 83, 115 ' s
									If PtrStrICmp( p, "sub" )=0 Then
										Call Me.ProcessRoutine( p, %DeclarationTypes.eSub, "sub", -1 )
									Else
										GoTo NotInitialToken
									End If
								Case 84, 116 ' t
									If PtrStrICmp( p, "thread" )=0 Then
										Call Me.ProcessRoutine( p, %DeclarationTypes.eFunction, "function", -1 )
									Else
										GoTo NotInitialToken
									End If
								Case Else
									GoTo NotInitialToken
							End Select
						Else
							GoTo NotInitialToken
						End If
					Case 69, 101 ' e
						If PtrStrICmp( p, "enum" )=0 Then
							Call Me.ProcessBlock( %DeclarationTypes.eEnum, "enum" )
						Else
							GoTo NotInitialToken
						End If
					Case 70, 102 ' f
						If PtrStrICmp( p, "fastproc")=0 Then
							Call Me.ProcessRoutine( p, %DeclarationTypes.eFastProc, "fastproc", 0 )
						ElseIf PtrStrICmp( p, "function" )=0 Then
							Call Me.ProcessRoutine( p, %DeclarationTypes.eFunction, "function", 0 )
						Else
							GoTo NotInitialToken
						End If
					Case 71, 103 ' g
						If PtrStrICmp( p, "global" )=0 Then
							Call Me.ProcessVar( -1 )
						Else
							GoTo NotInitialToken
						End If
					Case 73, 105: ' i
						If PtrStrICmp( p, "interface" ) = 0 Then
							Call Me.ProcessInterface( -1, -1 ): ' No Class, Single line definitions
						Else
							GoTo NotInitialToken
						End If
					Case 77, 109 ' m
						If PtrStrICmp( p, "macro" )=0 Then
							Call Me.ProcessMacro()
						Else
							GoTo NotInitialToken
						End If
					Case 83, 115 ' s
						If PtrStrICmp( p, "sub" )=0 Then
							Call Me.ProcessRoutine( p, %DeclarationTypes.eSub, "sub", 0 )
						Else
							GoTo NotInitialToken
						End If
					Case 84, 116 ' t
						If PtrStrICmp( p, "thread" )=0 Then
							Call Me.ProcessRoutine( p, %DeclarationTypes.eFunction, "function", 0 )
						ElseIf PtrStrICmp( p, "threaded" )=0 Then
							Call Me.ProcessVar( -1 )
						ElseIf PtrStrICmp( p, "type" )=0 Then
							Call Me.ProcessBlock( %DeclarationTypes.eType, "type" )
						Else
							GoTo NotInitialToken
						End If
					Case 85, 117 ' u
						If PtrStrICmp( p, "union" )=0 Then
							Call Me.ProcessBlock( %DeclarationTypes.eUnion, "union" )
						Else
							GoTo NotInitialToken
						End If
					Case Else
				End Select
				Iterate Loop
NotInitialToken:
				' Labels always embedded, can't be here
				Call Me.MoveToEndOfStatement()
			Loop
			#Debug Code On
		End Method
	End Interface

	Class Method GetLine() As String
		#Debug Code Off
		Local o, c, tknTyp, startrow, startcol, endcol, endrow As Long
		Local p As StringZ Ptr
		Local sb As IStringBuilderA
		Local value As String


		sb = Class "StringBuilderA"
		startrow = row_
		tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
		tokenizer_.GetToken( tkn_, p, c, tknTyp )
		startcol = c
		While Me.NextStatementToken( p, c, tknTyp )
		Wend
		If @p=":" Then endcol = c-1 Else endcol = c+Len(@p)
		endrow = row_
		For c = startrow To endrow
			If c>startrow Then sb.Add( $CrLf )
			value = sf_.Line( c )
			If c=endrow Then value = Left$(  value, endcol+1 )
			If c=startrow Then value = Mid$( value, startcol+1 )
			sb.Add( Trim$( value ) )
		Next
		value = sb.String
		'RemoveContinuation( value )
		Method = value
		#Debug Code On
	End Method

	Class Method ProcessMacro()
		#Debug Code Off
		Local p As Byte Ptr
		Local c, tknTyp As Long

		If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
		If PtrStrICmp( p, "function" ) = 0 Then
			If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
		End If
		Call Me.AddDeclaration( p, fileNumber_, startLine_, startToken_, %DeclarationTypes.eMacro )
		While Me.NextStatementToken( p, c, tknTyp )
			If @p = %cEqual Then
				Call Me.MoveToEndOfStatement()
				Exit Method
			End If
		Wend
		Me.FindEnd( "macro" )
		#Debug Code On
	End Method

	Class Method ProcessVar( ByVal parentIndex As Long )
		#Debug Code Off
		Local p As Byte Ptr
		Local c, tknTyp, indent As Long

		Do
			If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
			If @p=%cComma Then
				' Skipping over this
			ElseIf PtrStrICmp( p, "as" ) = 0 Then
				Exit Loop
			ElseIf @p=%cLParen Then
				While Me.NextStatementToken( p, c, tknTyp )
					If @p=%cRParen Then Exit Loop
				Wend
				If @p<>%cRParen Then Exit Method: ' End of Statement
			ElseIf tknTyp=%TokenTypes.eIdentifier Then
				Call Me.AddDeclaration( p, fileNumber_, startLine_, startToken_, %DeclarationTypes.eVariable, parentIndex )
			End If
		Loop
		Me.MoveToEndOfStatement()
		#Debug Code On
	End Method

	Class Method ProcessParameters( ByVal parentIndex As Long )
		#Debug Code Off
		Local p As Byte Ptr
		Local c, tknTyp, indent As Long

		Do
			If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
			If @p=%cComma Or PtrStrICmp( p, "byval" ) = 0 Or PtrStrICmp( p, "byref" )=0 Or PtrStrICmp( p, "optional")=0 Then
				' Moving on
			ElseIf PtrStrICmp( p, "as" ) = 0 Then
				If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method: ' Skip type
			ElseIf @p=%cLParen Then
				While Me.NextStatementToken( p, c, tknTyp )
					If @p=%cRParen Then Exit Loop
				Wend
				If @p<>%cRParen Then Exit Method
			ElseIf @p=%cRParen Then
				Exit Loop
			ElseIf tknTyp=%TokenTypes.eIdentifier Then
				Call Me.AddDeclaration( p, fileNumber_, startLine_, startToken_, %DeclarationTypes.eVariable, parentIndex )
			End If
		Loop
		Me.MoveToEndOfStatement()
		#Debug Code On
	End Method


	Class Method ProcessClass()
		#Debug Code Off
		Local p As Byte Ptr
		Local c, tknTyp, classIndex As Long

		If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
		classIndex = Me.AddDeclaration( p, fileNumber_, startLine_, startToken_, %DeclarationTypes.eClass )
		Me.MoveToEndOfStatement()
		Do While -1
			If row_ >= sf_.Count Then Exit Method
			If Not Me.NextStatementToken( p, c, tknTyp ) Then Iterate Loop
			Select Case @p
				Case 69, 101: ' e
					If PtrStrICmp( p, "end" ) = 0 Then
						If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
						If PtrStrICmp( p, "class" ) = 0 Then
							Exit Loop
						Else
							Me.MoveToEndOfStatement()
						End If
					End If
				Case 67, 99:  ' c
					If PtrStrICmp( p, "class" ) = 0 Then
						startLine_ = row_
						startToken_ = tkn_
						Call Me.ProcessRoutine( p, %DeclarationTypes.eClassMethod, "method", 0, classIndex )
					Else
						Me.MoveToEndOfStatement()
					End If
				Case 73, 105: ' i
					If PtrStrICmp( p, "interface" ) = 0 Then
						startLine_ = row_
						startToken_ = tkn_
						Call Me.ProcessInterface( classIndex, 0 )
					ElseIf PtrStrICmp( p, "instance" ) = 0 Then
						startLine_ = row_
						startToken_ = tkn_
						Me.ProcessVar( classIndex )
					Else
						Me.MoveToEndOfStatement()
					End If
			End Select
		Loop
		#Debug Code On
	End Method

	Class Method ProcessInterface( ByVal classIndex As Long, ByVal singleLine As Long )
		#Debug Code Off
		Local p As Byte Ptr
		Local c, tknTyp, interfaceIndex As Long

		If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
		interfaceIndex = Me.AddDeclaration( p, fileNumber_, startLine_, startToken_, %DeclarationTypes.eInterface, classIndex )
		Me.MoveToEndOfStatement()
		Do While -1
			If row_ >= sf_.Count Then Exit Method
			If Not Me.NextStatementToken( p, c, tknTyp ) Then Iterate Loop
			Select Case @p
				Case 69, 101: ' e
					If PtrStrICmp( p, "end" ) = 0 Then
						If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
						If PtrStrICmp( p, "interface" ) = 0 Then
							Exit Loop
						End If
					End If
				Case 77, 109: ' m
					If PtrStrICmp( p, "method" ) = 0 Then
						startLine_ = row_
						startToken_ = tkn_
						Call Me.ProcessRoutine( p, %DeclarationTypes.eMethod, "method", singleLine, -1, interfaceIndex )
					End If
				Case 79, 111: ' o
					If PtrStrICmp( p, "override" )= 0 Then
						startLine_ = row_
						startToken_ = tkn_
						If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
						Select Case @p
							Case 77, 109: ' m
								If PtrStrICmp( p, "method" ) = 0 Then
									Call Me.ProcessRoutine( p, %DeclarationTypes.eMethod, "method", singleLine, -1, interfaceIndex )
								End If
							Case 80, 112: ' p
								If PtrStrICmp( p, "property" ) = 0 Then
									Call Me.ProcessRoutine( p, %DeclarationTypes.eProperty, "property", singleLine, -1, interfaceIndex )
								End If
						End Select
					End If
				Case 80, 112: ' p
					If PtrStrICmp( p, "property" ) = 0 Then
						startLine_ = row_
						startToken_ = tkn_
						Call Me.ProcessRoutine( p, %DeclarationTypes.eProperty, "property", singleLine, -1, interfaceIndex )
					End If
			End Select
		Loop
		#Debug Code On
	End Method

	Class Method ProcessShort( typeOfDeclaration As Dword, endType As String)
		#Debug Code Off
		Local p As Byte Ptr
		Local c, tknTyp As Long

		Me.NextStatementToken( p, c, tknTyp )
		Call Me.AddDeclaration( p, fileNumber_, startLine_, startToken_, typeOfDeclaration )
		Me.FindEnd( endType )
		#Debug Code On
	End Method

	Class Method ProcessConstant( tokenPtr As Dword)
		#Debug Code Off

		Call Me.AddDeclaration( tokenPtr, fileNumber_, startLine_, startToken_, %DeclarationTypes.eConstant )
		Call Me.MoveToEndOfStatement()
		#Debug Code On
	End Method

	Class Method ProcessBlock( typeOfDeclaration As Dword, endType As String)
		#Debug Code Off
		Local p As Byte Ptr
		Local c, tknTyp, parentIndex As Long

		Me.NextStatementToken( p, c, tknTyp )
		parentIndex = Me.AddDeclaration( p, fileNumber_, startLine_, startToken_, typeOfDeclaration )
		Me.MoveToEndOfStatement()
		Do
			If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Loop
			If PtrStrICmp( p, "end" ) = 0 Then
				If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Loop
				If PtrStrICmp( p, endType ) = 0 Then Exit Loop
			End If
			Call Me.AddDeclaration( p, fileNumber_, row_, tkn_, %DeclarationTypes.eField, parentIndex )
			Me.MoveToEndOfStatement()
		Loop
		#Debug Code On
	End Method

	Class Method ProcessRoutine( bp As Dword, typeOfDeclaration As Dword, endType As String, ByVal singleLine As Long, Optional classIndex As Long, Optional interfaceIndex As Long )
		#Debug Code Off
		Local p As Byte Ptr
		Local c, tknTyp As Long
		Local parentIndex, childIndex As Long

		If IsFalse IsMissing( interfaceIndex ) Then
			parentIndex = interfaceIndex
		ElseIf IsFalse IsMissing( classIndex ) Then
			parentIndex = classIndex
		Else
			parentIndex = -1
		End If

		p = bp

		If PtrStrICmp( p, endType )<>0 Then
			Do While Me.NextStatementToken( p, c, tknTyp )
				If PtrStrICmp( p, endType )=0 Then Exit Loop: ' Looking for function/sub/fastproc/property/method (or some routine)
			Loop
		End If
		If PtrStrICmp( p, endType )<>0 Then Exit Method: ' Something went wrong...
		If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
		' Lib/Import and Alias will always come after name
		If typeOfDeclaration=%DeclarationTypes.eProperty And (PtrStrICmp( p, "get" ) = 0 Or PtrStrICmp( p, "set" ) = 0) Then
			If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
		End If
		If PtrStrICmp( p, "=" ) = 0 Or PtrStrICmp( p, "objresult" )=0 Then
			While Me.NextStatementToken( p, c, tknTyp )
			Wend
			Exit Method
		End If
		childIndex = Me.AddDeclaration( p, fileNumber_, startLine_, startToken_, typeOfDeclaration, parentIndex )
		While Me.NextStatementToken( p, c, tknTyp )
			If @p = %cLParen Then Exit Loop
		Wend
		If @p = %cLParen Then Call Me.ProcessParameters( childIndex )
		If singleLine Then Exit Method
		Do
			If Not Me.NextStatementToken( p, c, tknTyp ) Then
				If row_ < sf_.Count Then Iterate Loop
				Exit Method
			End If
			Select Case Const @p
				Case 69, 101: ' e
					If PtrStrICmp( p, "end" ) = 0 Then
						If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Method
						If PtrStrICmp( p, endType ) = 0 Then
							Exit Loop
						End If
					End If
			End Select
			If Me.CheckVar( p, c, tknTyp, childIndex ) Then Iterate Loop
			'TODO: Add references
		Loop
		#Debug Code On
	End Method

	Class Method CheckVar( bp As Dword, c As Long, tknTyp As Long, ByVal parentIndex As Long ) As Long
		#Debug Code Off
		Local p As Byte Ptr
		p = bp

		Select Case @p
				Case 68, 100: 'd
					If PtrStrICmp( p, "dim")=0 Then
						startLine_ = row_
						startToken_ = tkn_
						Call Me.ProcessVar( parentIndex )
						Method = -1
					End If

				Case 71, 103: 'g
					If PtrStrICmp( p, "global")=0 Then
						startLine_ = row_
						startToken_ = tkn_
						Call Me.ProcessVar( -1 )
						Method = -1
					End If

				Case 73, 105: 'i
					If PtrStrICmp( p, "instance")=0 Then
						startLine_ = row_
						startToken_ = tkn_
						Call Me.ProcessVar( parentIndex )
						Method = -1
					End If

				Case 76, 108: 'l
					If PtrStrICmp( p, "local")=0 Then
						startLine_ = row_
						startToken_ = tkn_
						Call Me.ProcessVar( parentIndex )
						Method = -1
					End If

				Case 83, 115: 's
					If PtrStrICmp( p, "static")=0 Then
						startLine_ = row_
						startToken_ = tkn_
						Call Me.ProcessVar( parentIndex )
						Method = -1
					End If

				Case 84, 116: 't
					If PtrStrICmp( p, "threaded")=0 Then
						startLine_ = row_
						startToken_ = tkn_
						Call Me.ProcessVar( -1 )
						Method = -1
					End If
			End Select
			#Debug Code On
	End Method

	Class Method FindEnd( endType As String )
		#Debug Code Off
		Local p As StringZ Ptr
		Local c, tknTyp As Long

		Do
			If row_ >= sf_.Count Then Exit Loop
			If Not Me.NextStatementToken( p, c, tknTyp ) Then Iterate Loop
			If PtrStrICmp( p, "end" )=0 Then
				If Not Me.NextStatementToken( p, c, tknTyp ) Then Iterate Loop
				If PtrStrICmp( p, endType ) = 0 Then
					Exit Loop
				End If
			End If
			Me.MoveToEndOfStatement()
		Loop While row_ < sf_.Count
		#Debug Code On
	End Method

	Class Method AddDeclaration( ByVal p As Dword, ByVal fileNumber As Long, ByVal lineNumber As Long, ByVal tokenNumber As Long, ByVal typeOfDeclaration As Long, Optional parentIndex As Long ) As Long
		#Debug Code Off
		Local sp As StringZ Ptr
		Local pKey As String
		Local nameIndex As Long
		Local pIndex As Long

		pIndex = IIf&( IsMissing( parentIndex ), -1, parentIndex )

		sp = p
		pKey = @sp
		nameIndex = names_.AddDeclaration( pKey, count_ )
		If count_ >= size_ Then
			size_ += 100
			ReDim Preserve decl_( size_ )
		End If
		decl_( count_ ).tFileNumber   = fileNumber
		decl_( count_ ).tLineNumber   = lineNumber
		decl_( count_ ).tTokenNumber  = tokenNumber
		decl_( count_ ).tNameIndex    = nameIndex
		decl_( count_ ).tDeclType     = typeOfDeclaration
		decl_( count_ ).tParent       = pIndex
		Method = count_
		Incr count_
		#Debug Code On
	End Method

	Class Method MoveToEndOfStatement()
		#Debug Code Off
		Local p, c, tknTyp As Long

		While Me.NextStatementToken( p, c, tknTyp )
		Wend
		#Debug Code On
	End Method

	Class Method NextStatementToken( bp As Dword, c As Long, tknTyp As Long ) As Long
		'#Debug Code Off
		Local p As Byte Ptr
		p = bp
		If row_ >= sf_.Count Then Exit Method:            ' End of file

		If tkn_ >= tokenizer_.Count Then
			' We were at end of line, moving on...
			tkn_ = 0
			Incr row_
			If row_ >= sf_.Count Then Exit Method:           ' End of file
			tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
		Else
			Incr tkn_
		End If
		If tkn_ >= tokenizer_.Count Then Exit Method: ' End of line

		tokenizer_.GetToken( tkn_, p, c, tknTyp )
		If @p = %cColon Then
			bp = p
			Exit Method
		End If
		If @p <> %cUnderline Then
			bp = p
			Method = -1
			Exit Method
		End If

		' Continuing to next line
		tkn_ = 0
		Do
			Incr row_
			If row_ >= sf_.Count Then Exit Method:          ' End of file
			tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
			If tokenizer_.Count = 0 Then Exit Method:   ' End of statement
			tokenizer_.GetToken( tkn_, p, c, tknTyp )
			If @p=%cColon Then Exit Method:              ' End of statement
		Loop While @p=%cUnderline:                     ' Continuing again...
		bp = p
		Method = -1
		'#Debug Code On
	End Method

	'=================================================================
	Class Method cmGetDefinition( ByVal index As Long ) As String
		Local startrow, startcol, endrow, endcol As Long
		Local o, c, tknTyp As Long
		Local p As StringZ Ptr
		Local sb As IStringBuilderA
		Local value As String

		' Retrieve text for declaration (full sub/function/class, etc)
		If index<0 Or index >= count_ Then Exit Method
		value = GetEndWord( decl_( index ).tDeclType )
		If value="" Then
			Method = Me.cmGetSignature( index )
			Exit Method
		End If

		sb = Class "StringBuilderA"
		row_ = decl_( index ).tLineNumber
		startrow = row_
		tkn_ = decl_( index ).tTokenNumber
		tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
		tokenizer_.GetToken( tkn_, p, c, tknTyp )
		startcol = c
		If tknTyp = %TokenTypes.eConstant Or PtrStrICmp( p, "declare" ) = 0 Then
			Method = Me.cmGetSignature( index )
			Exit Method
		End If
		If PtrStrICmp( p, "macro") = 0 Then
			While Me.NextStatementToken( p, c, tknTyp )
				If @p="=" Then
					While Me.NextStatementToken( p, c, tknTyp )
					Wend
					endrow = row_
					endcol = c + Len( @p )
					Exit Loop
				End If
			Wend
			If endrow=0 Then
				row_ = startrow
				tkn_ = decl_( index ).tTokenNumber
				tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
				tokenizer_.GetToken( tkn_, p, c, tknTyp )
			End If
		End If

		If endrow=0 Then
			Me.FindEnd( value )
			endrow = row_
			tokenizer_.GetToken( tkn_, p, c, tknTyp )
			endcol = c + Len(@p)
		End If
		For c = startrow To endrow
			If c>startrow Then sb.Add( $CrLf )
			If c>=sf_.Count Then Exit For
			value = sf_.Line( c )
			If c=endrow Then value = Left$(  value, endcol+1 )
			If c=startrow Then value = Mid$( value, startcol+1 )
			sb.Add( value )
		Next
		Method = sb.string
	End Method

	Class Method cmStandardizeExportAliases( exportList As String )
		Local i, isExport As Long
		Local p As StringZ Ptr
		Local sig, sig2 As String
		Local lookFor, value As String
		Local c, tknTyp, fn As Long
		Local exportLst As iStringBag
		Local l() As String
		Local startrow, startcol, r2, t2, c2 As Long

		c = StrSplit( exportList, l(), $CrLf )
		Call NewStringBag( exportLst, c, c )
		For i = 0 To c-1
			If Len( l(i) )=0 Then
				exportLst.Add( l(i) )
			End If
		Next

		For i=0 To count_-1
			If decl_(i).tFileNumber <> fileNumber_ Or (decl_(i).tDeclType <> %DeclarationTypes.eSub And decl_(i).tDeclType <> %DeclarationTypes.eFunction) Then Iterate For
			lookFor = names_.Key( decl_(i).tNameIndex )
			isExport = exportLst.Contains(  lookFor )

			Select Case Const decl_(i).tDeclType
				Case %DeclarationTypes.eSub: lookFor = "sub"
				Case %DeclarationTypes.eFunction: lookFor = "function"
			End Select
			sig = LCase$( Me.cmGetSignature( i ) ) + " "
			Replace $Tab With " " In sig

			If InStr( sig, "declare ")>0 And InStr( sig, " lib ")>0 Then Iterate For
			If Not isExport And InStr( sig, " export ")=0 Then Iterate For

			' build new signature with Alias "name" in it
			row_ = decl_( i ).tLineNumber
			tkn_ = decl_( i ).tTokenNumber
			tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
			tokenizer_.GetToken( tkn_, p, c, tknTyp )
			Do
				If PtrStrICmp( p, lookFor )=0 Then
					Me.NextStatementToken( p, c, tknTyp )
					lookFor = @p
					r2 = row_
					t2 = tkn_
					c2 = c+Len( @p )
					Local x,y,z As String
					If Me.NextStatementToken( p, c, tknTyp ) And PtrStrICmp( p, "alias")=0 Then
						If Me.NextStatementToken( p, c, tknTyp ) Then
							value = sf_.Line( row_ )
							x = Left$( value, c )
							y = Mid$( value, c+Len(@p)+1 )
							value= x + Wrap$( lookFor, $Dq, $Dq ) + y
							sf_.Line( row_ ) = value
						End If
					Else
						value = sf_.Line( r2 )
						x = Left$( value, c2 )
						y = Mid$( value, c2+1 )
						value = x + " Alias " + Wrap$( lookFor, $Dq, $Dq ) + y
						sf_.Line( r2 ) = value
					End If
					Exit Loop
				End If
			Loop While Me.NextStatementToken( p, c, tknTyp )
		Next
	End Method

	Class Method cmAddDebugAliases()
		Local i, par As Long
		Local p As StringZ Ptr
		Local sig, sig2 As String
		Local lookFor, value As String
		Local c, tknTyp As Long
		Local startrow, startcol, r2, t2, c2 As Long
		Local map As iStringStringMap
		Local cnt As Long

		Call NewStringStringMap( map, 50000, 1000 )

		For i=0 To count_-1
			If decl_(i).tFileNumber<>fileNumber_ Then Iterate For
			Select Case Const decl_(i).tDeclType
				' Excluding
				Case %DeclarationTypes.eSub, _
							%DeclarationTypes.eFunction, _
							%DeclarationTypes.eMethod, _
							%DeclarationTypes.eProperty
					Select Case Const decl_(i).tDeclType
						Case %DeclarationTypes.eSub: lookFor = "sub"
						Case %DeclarationTypes.eFunction: lookFor = "function"
						Case %DeclarationTypes.eMethod: lookFor = "method"
						Case %DeclarationTypes.eProperty: lookFor = "property"
					End Select
					' build new signature with Alias "name" in it
					row_ = decl_( i ).tLineNumber
					tkn_ = decl_( i ).tTokenNumber
					tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
					tokenizer_.GetToken( tkn_, p, c, tknTyp )
					Do
						If PtrStrICmp( p, "private" )=0 Or PtrStrICmp( p, "callback" )=0 Or PtrStrICmp( p, "thread" ) = 0 Then
							Exit Loop
						End If
						If PtrStrICmp( p, lookFor )=0 Then
							If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Loop
							If PtrStrICmp( p, "set" ) = 0 Or PtrStrICmp( p, "get" ) = 0 Then
								If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Loop
							End If
							Incr cnt
							lookFor = @p
							If decl_( i ).tDeclType = %DeclarationTypes.eMethod Or decl_( i ).tDeclType = %DeclarationTypes.eProperty Or decl_( i ).tDeclType = %DeclarationTypes.eClassMethod Then
								par = decl_( i ).tParent
								While par>-1 And ( decl_( par ).tDeclType = %DeclarationTypes.eInterface Or decl_( par ).tDeclType = %DeclarationTypes.eClass)
									lookFor += "." + names_.Key( decl_( par ).tNameIndex )
									par = decl_( par ).tParent
								Wend
							End If
							If map.Contains( lookFor ) Then
								value = map.Item( lookFor )
							Else
								value = DebugName( lookFor, cnt)
								map.Add( lookFor, value )
							End If
							value = Wrap$( value, $Dq, $Dq )
							r2 = row_
							t2 = tkn_
							c2 = c+Len( @p )
							If PtrStrICmp( p, "alias")=0 Then
								If Me.NextStatementToken( p, c, tknTyp ) Then
									sf_.Line( row_ ) = Left$( sf_.Line( row_ ), c ) + value + Mid$( sf_.Line( row_ ), c+Len(@p)+1 )
								End If
							Else
								sf_.Line( r2 ) = Left$( sf_.Line( r2 ), c2 ) + " Alias " + value + Mid$( sf_.Line( r2 ), c2+1 )
							End If
							Exit Loop
						End If
					Loop While Me.NextStatementToken( p, c, tknTyp )
			End Select
		Next
	End Method

	Class Method cmRemoveAliases()
		Local i As Long
		Local p As StringZ Ptr
		Local sig, sig2 As String
		Local lookFor, value As String
		Local c, tknTyp As Long
		Local startrow, startcol, r2, t2, c2 As Long

		For i=0 To count_-1
			If decl_(i).tFileNumber<>fileNumber_ Then Iterate For
			Select Case decl_(i).tDeclType
				Case %DeclarationTypes.eSub, _
							%DeclarationTypes.eFunction, _
							%DeclarationTypes.eMethod, _
							%DeclarationTypes.eProperty
					Select Case Const decl_(i).tDeclType
						Case %DeclarationTypes.eSub: lookFor = "sub"
						Case %DeclarationTypes.eFunction: lookFor = "function"
						Case %DeclarationTypes.eMethod: lookFor = "method"
						Case %DeclarationTypes.eProperty: lookFor = "property"
					End Select
					' build new signature without Alias "name" in it
					row_ = decl_( i ).tLineNumber
					tkn_ = decl_( i ).tTokenNumber
					tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
					tokenizer_.GetToken( tkn_, p, c, tknTyp )
					Do
						If PtrStrICmp( p, lookFor )=0 Then
							' Move to name
							If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Loop
							' If set or get, move again to get to real name
							If PtrStrICmp( p, "set" ) = 0 Or PtrStrICmp( p, "get" ) = 0 Then
								If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Loop
							End If
							' Skip over name
							If Not Me.NextStatementToken( p, c, tknTyp ) Then Exit Loop

							' If next word is lib or import, we need to leave any alias alone
							If PtrStrICmp( p, "alias")=0 Then
								r2 = row_
								t2 = c
								c2 = c+Len( @p )+1
								If Me.NextStatementToken( p, c, tknTyp ) Then
									' Remove alias name
									sf_.Line( row_ ) = Left$( sf_.Line( row_ ), c ) + Mid$( sf_.Line( row_ ), c+Len(@p)+1 )
								End If
								' Remove word alias
								If r2 = row_ Then c = 1 Else c = 0
								value = sf_.Line( r2 )
								While t2>1 And Mid$( value, t2, 1 ) <= " "
									Decr t2
								Wend
								sig = Left$( value, t2 ) + Mid$( value, c2+c )
'                Replace "  " With " " In sig
'                Replace " (" With "(" In sig
								sf_.Line( r2 ) = sig
							End If
							Exit Loop
						End If
					Loop While Me.NextStatementToken( p, c, tknTyp )
			End Select
		Next
	End Method

	Class Method cmGetSignature( ByVal index As Long ) As String
		Local o, c, tknTyp, startrow, startcol, endcol, endrow As Long
		Local p As StringZ Ptr
		Local bp As Byte Ptr
		Local sb As IStringBuilderA
		Local value As String
		Local isConst As Long

		Local fileName As String
		Local sfCount, fn, fnl As Long
		If IsNothing( sf_ ) Then Exit Method
		fileName = sf_.Filename
		sfCount = sf_.Count
		fn = decl_(index).tFileNumber
		fnl = fileNumber_


			' Retrieve declaration line
		If index>=0 And index<count_ Then
			sb = Class "StringBuilderA"
			row_ = decl_( index ).tLineNumber
			startrow = row_
			tkn_ = decl_( index ).tTokenNumber
			tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
			tokenizer_.GetToken( tkn_, p, c, tknTyp )
			bp = p
			isConst = (@bp=%cPercent Or @bp=%cDollar)
			startcol = c
			While Me.NextStatementToken( p, c, tknTyp )
				If Not isConst And @p="=" Then Exit Loop
			Wend
			If p And (@p=":" Or @p="=") Then endcol = c-1 Else endcol = c+Len(@p)
			endrow = row_
			For c = startrow To endrow
				If c>startrow Then sb.Add( $CrLf )
				value = sf_.Line( c )
				If c=endrow Then value = Left$(  value, endcol+1 )
				If c=startrow Then value = Mid$( value, startcol+1 )
				sb.Add( Trim$( value ) )
			Next
			value = RTrim$( sb.String )
			bp = StrPtr( value )
			For index = Len(value)-1 To 0 Step -1
				If @bp[index] > %cSpace Then Exit For
			Next
			value = Left$( value, index+1 )
			If Right$( value, 2 ) = " _" Then value = Left$( value, Len(value)-2 )
			Method = value
		End If
	End Method

	Class Method cmGetClassOutline( ByVal index As Long ) As String
		Local i, indent, ia, ifc, tp As Long
		Local sb As IStringBuilderA
		Local value As String

		If index<0 Or index >= count_ Then Exit Method
		If decl_( index ).tDeclType <> %DeclarationTypes.eClass Then Exit Method
		sb = Class "StringBuilderA"

		For i=index To count_-1
			ia = 0
			Select Case Const decl_( i ).tDeclType
				Case %DeclarationTypes.eClass
					If i<>index Then Exit For
					ia += 1
					ifc = -1
				Case %DeclarationTypes.eInterface
					If ifc<>-1 Then GoSub EndInterface
					If decl_( i ).tParent = index Then
						ia += 1
						ifc = i
					Else
						Exit For
					End If
				Case %DeclarationTypes.eClassMethod
					If ifc<>-1 Then GoSub EndInterface
					ifc = -1
					If decl_( i ).tParent <> index Then Exit For
				Case %DeclarationTypes.eMethod, %DeclarationTypes.eProperty
					If decl_( i ).tParent <> ifc Then Exit For
				Case %DeclarationTypes.eVariable, %DeclarationTypes.eReference
					Iterate For
				Case Else
					Exit For
			End Select
			value = Me.cmGetSignature( i )
			value = CompressSignature( value )
			If sb.Len Then sb.Add( $CrLf )
			sb.Add( Space$( indent*2) )
			sb.Add( value )
			If ia Then indent+=ia
		Next
		If ifc<>-1 Then GoSub EndInterface

		indent -=1
		If sb.Len Then sb.Add( $CrLf )
		sb.Add( "End Class" )
		value = sb.String
		Method = value
		Exit Method
EndInterface:
		indent -=1
		If sb.Len Then sb.Add( $CrLf )
		sb.Add( Space$( indent*2 ) )
		sb.Add( "End Interface" )
		Return
	End Method

	Class Method cmGetClassInterfaces( ByVal index As Long ) As String
		Local i As Long
		Local sb As IStringBuilderA
		Local tp As Long

		If index<0 Or index >= count_ Then Exit Method
		If decl_( index ).tDeclType <> %DeclarationTypes.eClass Then Exit Method
		sb = Class "StringBuilderA"

		For i=index+1 To count_-1
			Select Case Const decl_( i ).tDeclType
				Case %DeclarationTypes.eInterface
					If decl_( i ).tParent = index Then
						If sb.Len>0 Then sb.Add( $CrLf )
						sb.Add( names_.Key( decl_( i ).tNameIndex ) )
					Else
						Exit For
					End If
				Case %DeclarationTypes.eClassMethod
					If decl_( i ).tParent <> index Then Exit For
				Case %DeclarationTypes.eMethod, %DeclarationTypes.eProperty, %DeclarationTypes.eVariable, %DeclarationTypes.eReference
				Case Else
					Exit For
			End Select
		Next
		Method = sb.String
	End Method

	Class Method cmGetInstanceVariables( ByVal index As Long ) As String
		Local i As Long
		Local sb As IStringBuilderA
		Local tp As Long

		If index<0 Or index >= count_ Then Exit Method
		If decl_( index ).tDeclType <> %DeclarationTypes.eClass Then Exit Method
		sb = Class "StringBuilderA"

		For i=index+1 To count_-1
			Select Case Const decl_( i ).tDeclType
				Case %DeclarationTypes.eVariable
					If decl_( i ).tParent = index Then
						If sb.Len>0 Then sb.Add( $CrLf )
						sb.Add( names_.Key( decl_( i ).tNameIndex ) )
					Else
						Exit For
					End If
				Case %DeclarationTypes.eClassMethod, %DeclarationTypes.eInterface
					If decl_( i ).tParent <> index Then Exit For
				Case %DeclarationTypes.eMethod, %DeclarationTypes.eProperty, %DeclarationTypes.eReference
				Case Else
					Exit For
			End Select
		Next
		Method = sb.String
	End Method

	Class Method cmGetClassMethods( ByVal index As Long ) As String
		Local i As Long
		Local sb As IStringBuilderA
		Local tp As Long

		If index<0 Or index >= count_ Then Exit Method
		If decl_( index ).tDeclType <> %DeclarationTypes.eClass Then Exit Method
		sb = Class "StringBuilderA"

		For i=index+1 To count_-1
			Select Case Const decl_( i ).tDeclType
				Case %DeclarationTypes.eClassMethod
					If decl_( i ).tParent = index Then
						If sb.Len>0 Then sb.Add( $CrLf )
						sb.Add( names_.Key( decl_( i ).tNameIndex ) )
					Else
						Exit For
					End If
				Case %DeclarationTypes.eInterface
					If decl_( i ).tParent <> index Then Exit For
				Case %DeclarationTypes.eMethod, %DeclarationTypes.eProperty, %DeclarationTypes.eReference, %DeclarationTypes.eVariable
				Case Else
					Exit For
			End Select
		Next
		Method = sb.String
	End Method

	Class Method cmGetNames( ByVal tp As Long, Optional fileNumber As Long ) As String
		Local i As Long
		Local sb As IStringBuilderA
		Local u As iStringBag
		Local k As String
		Local fn As Long

		Call NewStringBag( u, 50000, 1000 )

		fn = IIf&( IsMissing( fileNumber ), -1, fileNumber )
		sb = Class "StringBuilderA"
		For i=0 To count_-1
			If (fn=-1 Or decl_(i).tFileNumber=fn) And decl_( i ).tDeclType = tp Then
				k = names_.Key( decl_( i ).tNameIndex )
				If Not u.Contains( k ) Then
					If sb.Len Then sb.Add( $CrLf )
					sb.Add( k )
				End If
			End If
		Next
		u = Nothing
		Method = sb.String
	End Method

	Class Method cmGetInterfaceRoutines( ByVal index As Long ) As String
		Local i As Long
		Local sb As IStringBuilderA
		Local unique As iStringBag
		Local value As String

		sb = Class "StringBuilderA"
		Call NewStringBag( unique, 10000, 1000 )
		If index<0 Or index>=count_ Then Exit Method
		If decl_( index ).tDeclType <> %DeclarationTypes.eInterface Then Exit Method

		For i = index+1 To count_ - 1
			Select Case decl_(i).tDeclType
				Case %DeclarationTypes.eVariable, %DeclarationTypes.eReference
				Case %DeclarationTypes.eMethod, %DeclarationTypes.eProperty
					If decl_( i ).tParent<>index Then Exit For
					value = names_.Key( decl_( i ).tNameIndex )
					If Not unique.Contains( value ) Then
						If sb.Len Then sb.Add( $CrLf )
						sb.Add( value )
						unique.Add( value )
					End If
				Case Else
					Exit For
			End Select
		Next
		Method = sb.String
	End Method

	Class Method cmGetInterfaceClasses( interfaceName As String ) As String
		Local i, j, c, di As Long
		Local sb As IStringBuilderA
		Local u As iStringBag
		Local v As String

		Call NewStringBag( u, 50000, 1000 )
		sb = Class "StringBuilderA"

		i = names_.Index( interfaceName )
		If i<0 Then Exit Method
		c = names_.DeclarationCount( i )
		For j = 0 To c-1
			di = names_.Declaration( i, j )
			di = decl_( di ).tParent
			If di<0 Then Iterate For
			v = names_.Key( decl_( di ).tNameIndex )
			If Not u.Contains( v ) Then
				u.Add( v )
				If sb.Len Then sb.Add( $CrLf )
				sb.Add( v )
			End If
		Next
		Method = sb.String
	End Method

	Class Method cmFindName( ByVal start As Long, value As String, ByVal declType As Long ) As Long
		Local i, ni As Long

		ni = names_.Index( value )
		If ni<0 Then Method=-1: Exit Method
		For i=start To count_-1
			If decl_( i ).tDeclType = declType And decl_( i ).tNameIndex = ni Then
				Method = i
				Exit Method
			End If
		Next
		Method = -1
	End Method

	Class Method cmGetInterfaceDeclaration( ByVal index As Long, constants As String ) As String
		Local n As String
		Local r As Long
		Local bp As StringZ Ptr
		Local cl, tt As Long
		Local value As String
		Local sb As IStringBuilderA

		sb = Class "StringBuilderA"

		If index<0 Or index >= count_ Then Exit Method
		If decl_( index ).tDeclType<>%DeclarationTypes.eInterface Then Exit Method
		row_ = decl_( index ).tLineNumber
		tkn_ = decl_( index ).tTokenNumber-1

		tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
		' Interface line
		While Me.NextStatementToken( bp, cl, tt )
			If @bp <> "_" And tt<>%TokenTypes.eRemark Then
				If Left$( @bp, 1 ) = "$" Then
					r = names_.Index( ByCopy @bp )
					If r>-1 Then
						r = names_.Declaration( r, 0 )
						If Len( constants ) Then constants += $CrLf
						value = Me.cmGetSignature( r )
						value = CompressSignature( value )
						constants += value
					End If
				End If
				If sb.Len Then sb.Add(" ")
				sb.Add( ByCopy @bp )
			End If
		Wend
		sb.Add( $CrLf )
		sb.Add(" ")
		' Inherit line
		While Me.NextStatementToken( bp, cl, tt )
			If @bp <> "_" And tt<>%TokenTypes.eRemark Then
				If sb.Len Then sb.Add(" ")
				sb.Add( ByCopy @bp )
			End If
		Wend
		sb.Add( $CrLf )
		For r = index+1 To count_-1
			Select Case decl_( r ).tDeclType
				Case %DeclarationTypes.eProperty, %DeclarationTypes.eMethod
					If decl_( r ).tParent <> index Then Exit For
					value = Me.cmGetSignature( r )
					value = CompressSignature( value )
					sb.Add( $CrLf )
					sb.Add( "  " )
					sb.Add( value )
				Case %DeclarationTypes.eVariable, %DeclarationTypes.eReference
				Case Else
					Exit For
			End Select
		Next
		sb.Add( $CrLf )
		sb.Add("End Interface")
		Method = sb.String
	End Method

	Class Method cmGetInterfaceStub( ByVal index As Long ) As String
		Local n As String
		Local r As Long
		Local bp As StringZ Ptr
		Local cl, tt As Long
		Local value As String
		Local sb As IStringBuilderA

		sb = Class "StringBuilderA"

		If index<0 Or index >= count_ Then Exit Method
		If decl_( index ).tDeclType<>%DeclarationTypes.eInterface Then Exit Method
		row_ = decl_( index ).tLineNumber
		tkn_ = decl_( index ).tTokenNumber-1

		tokenizer_.SetLinePointer( sf_.LinePointer( row_ ) )
		' Interface line
		While Me.NextStatementToken( bp, cl, tt )
			If @bp <> "_" And tt<>%TokenTypes.eRemark Then
				If sb.Len Then sb.Add(" ") Else sb.Add("  ")
				sb.Add( ByCopy @bp )
			End If
		Wend
		sb.Add( $CrLf )
		sb.Add("   ")
		' Inherit line
		While Me.NextStatementToken( bp, cl, tt )
			If @bp <> "_" And tt<>%TokenTypes.eRemark Then
				sb.Add(" ")
				sb.Add( ByCopy @bp )
			End If
		Wend
		sb.Add( $CrLf )
		For r = index+1 To count_-1
			Select Case decl_( r ).tDeclType
				Case %DeclarationTypes.eProperty, %DeclarationTypes.eMethod
					If decl_( r ).tParent <> index Then Exit For
					value = Me.cmGetSignature( r )
					value = CompressSignature( value )
					sb.Add( $CrLf )
					sb.Add( "    " )
					sb.Add( value )
					sb.Add( $CrLf )
					sb.Add( "    " )
					If decl_( r ).tDeclType = %DeclarationTypes.eProperty Then
						sb.Add( "End Property")
					Else
						sb.Add( "End Method" )
					End If
				Case %DeclarationTypes.eVariable, %DeclarationTypes.eReference
				Case Else
					Exit For
			End Select
		Next
		sb.Add( $CrLf )
		sb.Add("  End Interface")
		Method = sb.String
	End Method

	Class Method cmGetDLLDeclaration( libName As String, exportList As String, routines As String, interfaces As String, constants As String, enums As String, types As String, unions As String )
		Local constBag, unq As iStringBag
		Local v, v2, n As String
		Local i, c, t, t2, tc, cl, tt As Long
		Local lns(), aliasName As String
		Local bp As Byte Ptr
		Local sp As StringZ Ptr
		Local sb As IStringBuilderA
		Local sf As iSourceFile

		Call NewSourceFile( sf, "", 0 )
		sb = Class "StringBuilderA"
		Call NewStringBag( constBag, 10000, 1000 )
		Call NewStringBag( unq, 10000, 1000 )

		c = StrSplit( exportList, lns(), $CrLf )
		For i=0 To c-1
			unq.Add( lns(i) )
		Next

		For i=0 To count_-1
			If decl_(i).tFileNumber<>fileNumber_ Then Iterate For
			Select Case Const decl_( i ).tDeclType
				Case %DeclarationTypes.eSub, %DeclarationTypes.eFunction
					sb.Clear()
					n = names_.Key( decl_( i ).tNameIndex )
					v = Me.cmGetSignature( i )
					v = RemoveContinuation( v )
					Replace $Tab With " " In v
					v = Trim$( v )
					Replace "  " With " " In v
					v2 = LCase$( v )
					v2 = Build$( " ", v2, " " )
					If unq.Contains( n ) Or InStr( v2, " export ")>0 Then
						If Len( routines ) Then sb.Add( $CrLf )
						tokenizer_.SetLine( v )
						tc = tokenizer_.Count
						Select Case decl_( i ).tDeclType
							Case %DeclarationTypes.eSub
								sb.Add( "Declare Sub      " )
							Case %DeclarationTypes.eFunction
								sb.Add( "Declare Function " )
						End Select
						sb.Add( n )
						sb.Add( " Lib " )
						sb.Add( $Dq )
						sb.Add( libName )
						sb.Add( $Dq )
						tokenizer_.SetLine( v )
						aliasName = ""
						For t=0 To tokenizer_.Count-1
							tokenizer_.GetToken( t, sp, cl, tt )
							If PtrStrICmp( sp, "alias" ) = 0 Then
								tokenizer_.GetToken( t+1, sp, cl, tt )
								aliasName = @sp
								Exit For
							End If
						Next
						If aliasName<>"" Then
							sb.Add( " Alias " )
							sb.Add( aliasName )
						End If
						v2 = v
						t = InStr( v2, "(" )
						If t>0 Then
							v2 = Mid$( v2, t )
							t = InStr( -1, v2, ")" )
							If t>0 Then v2 = Left$( v2, t)
							sb.Add( v2 )
						End If
						v2 = LCase$( v )
						t2 = InStr( -1, v2, " as " )
						For t=0 To tc-1
							tokenizer_.GetToken( t, bp, cl, tt )
							If PtrStriCmp( bp, "threadsafe" )=0 Then sb.Add( " ThreadSafe" )
							If PtrStriCmp( bp, "BDecl" )=0 Then sb.Add( "BDecl" )
							If PtrStriCmp( bp, "CDecl" )=0 Then sb.Add( "CDecl" )
							If PtrStriCmp( bp, "SDecl" )=0 Then sb.Add( "SDecl" )
							Local jj As Long
							Local ss As String
							jj = %DeclarationTypes.eFunction
							sp = bp
							ss = @sp

							If decl_( i ).tDeclType = %DeclarationTypes.eFunction And _
									cl = t2 And _
									PtrStrICmp( bp, "as" )=0 Then
								sb.Add( " As " )
								tokenizer_.GetToken( t+1, sp, cl, tt )
								v = @sp
								sb.Add( v )
							End If
						Next
						routines += sb.String
					End If

				Case %DeclarationTypes.eConstant
					If Len(constants) Then constants += $CrLf
					v = Me.cmGetSignature( i )
					v = RemoveContinuation( v )
					v = TrimWhitespace( v )
					constants += v

				Case %DeclarationTypes.eInterface
					n = ""
					v = Me.cmGetInterfaceDeclaration( i, n )
					v2 = Parse$( v, $CrLf, 1 )
					t2 = InStr( v2, " ")
					t2 = InStr( t2+1, v2, " ")
					If t2>0 Then v2 = Trim$( Left$( v2, t2 ) )
					If InStr( LCase$(interfaces), LCase$( v2 ) )=0 Then
						If Len(interfaces) Then interfaces += Build$( $CrLf, $CrLf )
						interfaces += v
					End If

				Case %DeclarationTypes.eType
					If Len( types ) Then types += $CrLf + $CrLf
					v = Me.cmGetDefinition( i )
					v = RemoveContinuation( v )
					sf.Text = v
					indenter_.Indent( sf )
					sfExpandTabs( sf, 2 )
					v = sf.Text
					types += v

				Case %DeclarationTypes.eEnum
					If Len( enums ) Then enums += $CrLf + $CrLf
					v = Me.cmGetDefinition( i )
					v = RemoveContinuation( v )
					sf.Text = v
					indenter_.Indent( sf )
					sfExpandTabs( sf, 2 )
					v = sf.Text
					enums += v

				Case %DeclarationTypes.eUnion
					If Len( unions ) Then unions += $CrLf + $CrLf
					v = Me.cmGetDefinition( i )
					v = RemoveContinuation( v )
					sf.Text = v
					indenter_.Indent( sf )
					sfExpandTabs( sf, 2 )
					v = sf.Text
					unions += v
			End Select
		Next
	End Method

	Class Method cmGetSLLDeclaration( exportList As String, routines As String, interfaces As String, constants As String, enums As String, types As String, unions As String )
		Local constBag, unq As iStringBag
		Local v, v2, n As String
		Local i, c, t, t2, tc, cl, tt As Long
		Local lns(), aliasName As String
		Local bp As Byte Ptr
		Local sp As StringZ Ptr
		Local sb As IStringBuilderA
		Local sf As iSourceFile

		Call NewSourceFile( sf, "", 0 )
		sb = Class "StringBuilderA"
		Call NewStringBag( constBag, 10000, 1000 )
		Call NewStringBag( unq, 10000, 1000 )

		c = StrSplit( exportList, lns(), $CrLf )
		For i=0 To c-1
			unq.Add( lns(i) )
		Next

		For i=0 To count_-1
			If decl_(i).tFileNumber<>fileNumber_ Then Iterate For
			Select Case Const decl_( i ).tDeclType
				Case %DeclarationTypes.eSub, %DeclarationTypes.eFunction
					sb.Clear()
					n = names_.Key( decl_( i ).tNameIndex )
					v = Me.cmGetSignature( i )
					v = RemoveContinuation( v )
					Replace $Tab With " " In v
					v = Trim$( v )
					Replace "  " With " " In v
					v2 = LCase$( v )
					v2 = Build$( " ", v2, " " )
					If Left$( LTrim$(v2), 8) = "declare " Then Iterate For
					tokenizer_.SetLine( v )
					aliasName = ""
					For t = 0 To tokenizer_.Count-1
						tokenizer_.GetToken( t, bp, cl, tt )
						If PtrStrICmp( bp, "alias" ) = 0 Then
							tokenizer_.GetToken( t+1, sp, cl, tt )
							aliasName = @sp
							Exit For
						End If
					Next

					If InStr( v2, " common ")>0 Then
						If Len( routines ) Then sb.Add( $CrLf )
						tokenizer_.SetLine( v )
						tc = tokenizer_.Count
						Select Case decl_( i ).tDeclType
							Case %DeclarationTypes.eSub
								sb.Add( "Declare Sub " )
							Case %DeclarationTypes.eFunction
								sb.Add( "Declare Function " )
						End Select
						sb.Add( n )
						If aliasName<>"" Then
							sb.Add( " Alias " )
							sb.Add( aliasName )
						End If
						v2 = v
						t = InStr( v2, "(" )
						If t>0 Then
							v2 = Mid$( v2, t )
							t = InStr( -1, v2, ")" )
							If t>0 Then v2 = Left$( v2, t)
							sb.Add( v2 )
						End If
						For t=0 To tc-1
							tokenizer_.GetToken( t, bp, cl, tt )
							If PtrStrICmp( bp, "common" ) = 0 Then sb.Add( " Common" )
							If PtrStrICmp( bp, "threadsafe" )=0 Then sb.Add( " ThreadSafe" )
							If PtrStrICmp( bp, "BDecl" )=0 Then sb.Add( "BDecl" )
							If PtrStrICmp( bp, "CDecl" )=0 Then sb.Add( "CDecl" )
							If PtrStrICmp( bp, "SDecl" )=0 Then sb.Add( "SDecl" )
						Next
						routines += sb.String
					End If

				Case %DeclarationTypes.eInterface
					n = ""
					v = Me.cmGetInterfaceDeclaration( i, n )
					v2 = Parse$( v, $CrLf, 1 )
					t2 = InStr( v2, " ")
					t2 = InStr( t2+1, v2, " ")
					If t2>0 Then v2 = Trim$( Left$( v2, t2 ) )
					If InStr( LCase$(interfaces), LCase$( v2 ) )=0 Then
						If Len(interfaces) Then interfaces += Build$( $CrLf, $CrLf )
						interfaces += v
					End If

				Case %DeclarationTypes.eConstant
					If Len(constants) Then constants += $CrLf
					v = Me.cmGetSignature( i )
					v = RemoveContinuation( v )
					v = TrimWhitespace( v )
					constants += v

				Case %DeclarationTypes.eType
					If Len( types ) Then types += $CrLf + $CrLf
					v = Me.cmGetDefinition( i )
					v = RemoveContinuation( v )
					sf.Text = v
					indenter_.Indent( sf )
					sfExpandTabs( sf, 2 )
					v = sf.Text
					types += v

				Case %DeclarationTypes.eEnum
					If Len( enums ) Then enums += $CrLf + $CrLf
					v = Me.cmGetDefinition( i )
					v = RemoveContinuation( v )
					sf.Text = v
					indenter_.Indent( sf )
					sfExpandTabs( sf, 2 )
					v = sf.Text
					enums += v

				Case %DeclarationTypes.eUnion
					If Len( unions ) Then unions += $CrLf + $CrLf
					v = Me.cmGetDefinition( i )
					v = RemoveContinuation( v )
					sf.Text = v
					indenter_.Indent( sf )
					sfExpandTabs( sf, 2 )
					v = sf.Text
					unions += v
			End Select
		Next
	End Method
End Class

Function DebugName( baseName As String, ByVal num As Long ) As String
	Local num2 As String
	Local l As Long

	num2 = "_" + Format$( num, "00000" )
	l = 32 - Len(num2)
	Function = Left$( baseName, l ) + num2
End Function

Function BuildInc( heading As String, routines As String, interfaces As String, constants As String, enums As String, types As String, unions As String ) As String
	Local sb As IStringBuilderA
	Local r() As String, s() As String
	Local i, c, p As Long
	sb = Class "StringBuilderA"

	sb.Add( "' " )
	sb.Add( heading )

	If Len(constants) Then
		sb.Add( $CrLf )
		sb.Add( $CrLf )
		sb.Add( "' ===============================================" )
		sb.Add( $CrLf )
		sb.Add( "' Constants" )
		sb.Add( $CrLf )
		sb.Add( constants )
	End If

	If Len( enums ) Then
		sb.Add( $CrLf )
		sb.Add( $CrLf )
		sb.Add( "' ===============================================" )
		sb.Add( $CrLf )
		sb.Add( "' Enums" )
		sb.Add( $CrLf )
		sb.Add( enums )
	End If

	If Len( types ) Then
		sb.Add( $CrLf )
		sb.Add( $CrLf )
		sb.Add( "' ===============================================" )
		sb.Add( $CrLf )
		sb.Add( "' Types" )
		sb.Add( $CrLf )
		sb.Add( types )
	End If

	If Len( unions ) Then
		sb.Add( $CrLf )
		sb.Add( $CrLf )
		sb.Add( "' ===============================================" )
		sb.Add( $CrLf )
		sb.Add( "' Unions" )
		sb.Add( $CrLf )
		sb.Add( unions )
	End If

	If Len( interfaces ) Then
		sb.Add( $CrLf )
		sb.Add( $CrLf )
		sb.Add( "' ===============================================" )
		sb.Add( $CrLf )
		sb.Add( "' Interfaces" )
		sb.Add( $CrLf )
		sb.Add( interfaces )
	End If

	If Len( routines ) Then
		c = StrSplit( routines, r(), $CrLf )
		ReDim s(c-1)
		For i=0 To c-1
			s(i) = Mid$( r(i), 18 )
			p = InStr( s(i), " ")
			If p>0 Then s(i) = Left$( s(i), p )
		Next
		Array Sort s(), TagArray r()
		routines = Join$( r(), $CrLf )
		sb.Add( $CrLf )
		sb.Add( $CrLf )
		sb.Add( "' ===============================================" )
		sb.Add( $CrLf )
		sb.Add( "' Routines" )
		sb.Add( $CrLf )
		sb.Add( routines )
	End If
	Function = sb.String
End Function
