Function EnsurePath( fullPath As String ) As Long
'  Debug_Trace( "ensurefilepath.Start" )
	Local basePath, buildPath As String
	Local r As Long

	basePath = fullPath

	If Mid$( basePath, 2, 1 ) = ":" Then
		buildPath = Left$( basePath, 3 )
		basePath = Mid$( basePath, 4 )
	ElseIf Left$( basePath, 2 ) = "\\" Then
		r = InStr( 3, basePath, "\" )
		If r=0 Then Exit Function
		r = InStr( r+1, basePath, "\" )
		If r=0 Then Exit Function
		buildPath = Left$( basePath, r )
		basePath = Mid$( basePath, r+1 )
	End If

	While basePath<>""
		r = InStr( 2, basePath, "\" )
		If r=0 Then r=Len(basePath)+1
		buildPath += Left$( basePath, r-1 )
		basePath = Mid$( basePath, r )
		Try
			If Not IsFolder( buildPath ) Then
				MkDir buildPath
			End If
		Catch
			Function = Err
			Exit Function
		End Try
	Wend
End Function

Function EnsureFileAndPath( filename As String ) As Long
	Local fullPath As String
	Local f As Long

	fullPath = PathName$( Path, filename )

	f = EnsurePath( fullPath )
	If f Then
		Function = f
		Exit Function
	End If
	If Not IsFile( filename ) Then
		Try
			Open filename For Output As #f
			Print #f, "";
			Close #f
		Catch
			Function = Err
			Exit Function
		End Try
	End If
End Function

Function FindInclude( value As String, includeFile As String ) As Long
	#Debug Code Off
	Local p As Byte Ptr
	Register c As Long

	' Special purpse tokenizer, quickly discover filename for [$#]include [this] [once] "filename"
	p = StrPtr(value)

	' Skip white space
	While @p[c]=32 Or @p[c]=9
		Incr c
	Wend
	p += c

	If @p[0]<>35 And @p[0]<>36 Then Exit Function  ' #$
	If @p[1]<>73 And @p[1]<>105 Then Exit Function ' i
	If @p[2]<>78 And @p[2]<>110 Then Exit Function ' n
	If @p[3]<>67 And @p[3]<>99 Then Exit Function  ' c
	If @p[4]<>76 And @p[4]<>108 Then Exit Function ' l
	If @p[5]<>85 And @p[5]<>117 Then Exit Function ' u
	If @p[6]<>68 And @p[6]<>100 Then Exit Function ' d
	If @p[7]<>69 And @p[7]<>101 Then Exit Function ' e

	c=8
	While @p[c] And @p[c]<>34
		Incr c
	Wend
	If @p[c]=0 Then Exit Function
	Incr c: ' Skip over "
	p += c
	c=0
	' This special case string can't have embeded "'s, it's a filename...
	While @p[c] And @p[c]<>34
		Incr c
	Wend
	includeFile = Peek$( p, c )
	Function = -1
	#Debug Code On
End Function
