
Sub sfRemoveContinuation( sf As iSourceFile )
	Register i As Long
	Register j As Long
	Local k, c, p, cl, tt As Long
	Local bp As Byte Ptr
	Local v, u As String

	If IsFalse IsInterface( sf, iSourceFile ) Then Exit Sub
	For i=sf.Count-1 To 0 Step -1
		tokenizer_.SetLinePointer( sf.LinePointer(i) )
		For j = tokenizer_.Count - 1 To 0 Step -1
			tokenizer_.GetToken( j, bp, cl, tt )
			If tt = %TokenTypes.eContinue Then
				v = Left$( sf.Line(i), cl )
				v = RTrimWhitespace( v )
				u = sf.Line(i+1)
				u = TrimWhitespace( u )
				sf.Line(i) = v +  " " + u
				sf.DeleteText( i+1, 1 )
				Exit For
			End If
		Next
	Next
End Sub

Sub sfExpandTabs( sf As iSourceFile, ByVal tabSize As Long )
	Register charNo As Long
	Register lineNo As Long
	Local c As Long
	Local sb As IStringBuilderA
	Local bp As Byte Ptr

	If IsFalse IsInterface( sf, iSourceFile ) Then Exit Sub
	If tabSize<1 Then Exit Sub
	sb = Class "StringBuilderA"

	For lineNo=0 To sf.Count-1
		bp = sf.LinePointer(lineNo)
		sb.Clear()
		charNo=0
		While @bp[charNo]
			If @bp[charNo]=9 Then
				sb.Add(" ")
				c = tabSize - (sb.Len Mod tabSize)
				If c<tabSize Then sb.Add( Space$( c ) )
			Else
				sb.Add( Peek$( bp+charNo, 1 ) )
			End If
			Incr charNo
		Wend
		sf.Line(lineNo) = sb.String
	Next
	sb = Nothing
End Sub

Sub sfReplaceToken( sf As iSourceFile, originalToken As String, newToken As String )
	Local i, j, c, e, d, pCol, pType As Long
	Local sp As StringZ Ptr
	Local sb As IStringBuilderA

	If Not init_ Then Call Initialize()
	If IsFalse IsInterface( sf, iSourceFile ) Then Exit Sub

	sb = Class "StringBuilderA"

	d = Len(newToken) - Len( originalToken )

	For i=0 To sf.Count-1
		tokenizer_.SetLinePointer( sf.LinePointer(i) )
		sb.Clear()
		e = 0
		For j=0 To tokenizer_.Count-1
			Call tokenizer_.GetToken( j, sp, pCol, pType )
			While pCol+e > sb.Len
				sb.Add(" " )
			Wend
			If PtrStrICmp( sp, originalToken )=0 Then
				sb.Add( newToken )
				e += d
			Else
				sb.Add( ByCopy @sp )
			End If
		Next
		sf.Line(i) = sb.String
	Next
	sb = Nothing
End Sub

Sub sfManageBlankLines( sf As iSourceFile )
	Local i, j, c, cl, tt, lastAdd, addBefore, addBlank, b1, b2, cntDst, inType As Long
	Local bp As Byte Ptr
	Local dst As iSourceFile

	Call NewSourceFile( dst, sf.Filename, sf.IsExternal )

	If IsFalse IsInterface( sf, iSourceFile ) Then Exit Sub
	b1 = 0

	For i=0 To sf.Count-1
		addBlank = 0
		addBefore = 0
		tokenizer_.SetLinePointer( sf.LinePointer(i) )
		If tokenizer_.Count>1 Then
			tokenizer_.GetToken( 0, bp, cl, tt )
			If Not inType Then
				Select Case Const @bp
					Case 67, 99:  'c
						If PtrStrICmp( bp, "callback")=0 Then
							addBefore=-1
						ElseIf PtrStrICmp( bp, "class")=0 Then
							addBefore=-1
						End If

					Case 69, 101:  'e
						If PtrStrICmp( bp, "enum")=0 Then
							addBefore=-1
						End If

					Case 70, 102:  'f
						If PtrStrICmp( bp, "fastproc")=0 Then
							addBefore=-1
						ElseIf PtrStrICmp( bp, "function")=0 Then
							addBefore=-1
						End If

					Case 73, 105:  'i
						If PtrStrICmp( bp, "interface")=0 Then
							addBefore=-1
						End If

					Case 77, 109:  'm
						If PtrStrICmp( bp, "macro")=0 Then
							addBefore=-1
						ElseIf PtrStrICmp( bp, "method")=0 Then
							addBefore=-1
						End If

					Case 79, 111:  'o
						If PtrStrICmp( bp, "override")=0 Then
							addBefore=-1
						End If

					Case 80, 112:  'p
						If PtrStrICmp( bp, "property")=0 Then
							addBefore=-1
						End If

					Case 83, 115:  's
						If PtrStrICmp( bp, "sub")=0 Then
							addBefore=-1
						End If

					Case 84, 116:  't
						If PtrStrICmp( bp, "thread")=0 Then
							addBefore=-1
						ElseIf PtrStrICmp( bp, "type")=0 Then
							inType = -1
							addBefore=-1
						End If

					Case 85, 117:  'u
						If PtrStrICmp( bp, "union")=0 Then
							addBefore=-1
						End If
				End Select
			End If

			If PtrStrICmp( bp, "end" ) = 0 Then
				tokenizer_.GetToken( 1, bp, cl, tt )
				Select Case Const @bp
					Case 67, 99:  'c
						If PtrStrICmp( bp, "class")=0 Then
							addBlank=-1: lastAdd=0
						End If
					Case 69, 101:  'e
						If PtrStrICmp( bp, "enum")=0 Then
							addBlank=-1: lastAdd=0
						End If

					Case 70, 102:  'f
						If PtrStrICmp( bp, "function")=0 Then
							addBlank=-1: lastAdd=0
						End If

					Case 73, 105:  'i
						If PtrStrICmp( bp, "interface")=0 Then
							addBlank=-1: lastAdd=0
						End If

					Case 77, 109:  'm
						If PtrStrICmp( bp, "macro")=0 Then
							addBlank=-1: lastAdd=0
						ElseIf PtrStrICmp( bp, "method")=0 Then
							addBlank=-1: lastAdd=0
						End If

					Case 80, 112:  'p
						If PtrStrICmp( bp, "property")=0 Then
							addBlank=-1: lastAdd=0
						End If

					Case 83, 115:  's
						If PtrStrICmp( bp, "sub")=0 Then
							addBlank=-1: lastAdd=0
						End If

					Case 84, 116:  't
						If PtrStrICmp( bp, "type")=0 Then
							addBlank=-1: lastAdd=0: inType = 0
						End If

					Case 85, 117:  'u
						If PtrStrICmp( bp, "union")=0 Then
							addBlank=-1: lastAdd=0
						End If
				End Select
			End If
		End If
		b2 = CheckBlank( sf.Line(i) )
		If Not (b1 And b2) Then
			If addBefore And Not (b2 Or b1) Then
				dst.AddText("")
				b2 = -1: ' Last line was blank
			End If
			If lastAdd And Not (b2 Or b1) Then
				dst.AddText("")
				b2 = -1: ' Last line was blank
			End If
			dst.AddText( sf.Line(i) )
		End If
		lastAdd = addBlank
		b1 = b2
	Next
	j = dst.Count-1
	While j>0 And CheckBlank( dst.Line(i) )
		Decr j
	Wend
	dst.Count = j
	sf = Nothing
	sf = dst
End Sub

Function sfFindExports( sf As iSourceFile) As String
	Local lns(), value As String
	Local i, j, c, c2, cl, tk As Long
	Local bp As StringZ Ptr
	Local sb As IStringBuilderA
	Local unique As iStringBag

	sb = Class "StringBuilderA"
	Call NewStringBag( unique, 10000, 1000 )

	For i=0 To sf.Count-1
		tokenizer_.SetLinePointer( sf.LinePointer(i) )
		c2 = tokenizer_.Count
		If c2>0 Then
			tokenizer_.GetToken( 0, bp, cl, tk )
			If PtrStrICmp( bp, "#export" )=0 Then
				For j=1 To c2-1 Step 2
					' Skipping comma's
					tokenizer_.GetToken( j, bp, cl, tk )
					value = @bp
					If Not unique.Contains( value ) Then
						If sb.Len Then sb.Add( $CrLf )
						sb.Add( value )
						unique.Add( value )
					End If
				Next
			End If
		End If
	Next
	unique = Nothing
	Function = sb.String
End Function

Sub sfTrimWhitespace( sf As iSourceFile )
	Local i As Long
	Local value As String

	If Not init_ Then Call Initialize()
	If IsNothing( sf ) Then Exit Sub
	For i=0 To sf.Count-1
		value = sf.Line(i)
		value = TrimWhitespace( value )
		sf.Line(i) = value
	Next
End Sub

Function sfFileClose( map As iStringSourcefileMap, snippetName As String ) As Long
	Local newMap As iStringSourcefileMap
	Local sf As iSourceFile
	Local i, index As Long
	Local value As String

	Function = -1
	index = map.Index( snippetName )
	If index<0 Or index >= map.Count Then Exit Function

	Call NewStringSourcefileMap( newMap, 400, 10 )
	For i=0 To map.Count-1
		If i<>index Then
			value = map.Key( i )
			sf = map.Value( i )
			newMap.Add( value, sf )
			sf = Nothing
		End If
	Next
	map.Clear()
	map = Nothing
	map = newMap
	newMap = Nothing
	Function = index
End Function

Function sfDeclareGetInterfaces( oDecl As iDeclarations ) As String
	Local i, j, c As Long
	Local decl As TDecl
	Local names As iStringBag
	Local list As String
	Local v() As String

	If Not init_ Then Call Initialize()
	If IsNothing( oDecl ) Then Exit Function
	Call NewStringBag( names, 5000, 100 )

	For i=0 To oDecl.Count-1
		decl = oDecl.Item( i )
		If decl.tDecltype = %DeclarationTypes.eClass And decl.tFileNumber=oDecl.FileNumber Then
			list = oDecl.GetClassInterfaces( i )
			c = StrSplit( list, v(), $CrLf )
			For j=0 To c-1
				If v(j)<>"" Then
					names.Add( v(j) )
				End If
			Next
		End If
	Next
	If names.Count>0 Then
		ReDim v( names.Count-1 )
		For i=0 To names.Count-1
			v(i) = names.Key( i )
		Next
		Array Sort v(), Collate UCase
		Function = Join$( v(), $CrLf )
	End If
End Function
