' Lower case translation table
AsmData LowerCaseBytes
	DB &H00, &H01, &H02, &H03, &H04, &H05, &H06, &H07, &H08, &H09, &H0A, &H0B, &H0C, &H0D, &H0E, &H0F
	DB &H10, &H11, &H12, &H13, &H14, &H15, &H16, &H17, &H18, &H19, &H1A, &H1B, &H1C, &H1D, &H1E, &H1F
	DB &H20, &H21, &H22, &H23, &H24, &H25, &H26, &H27, &H28, &H29, &H2A, &H2B, &H2C, &H2D, &H2E, &H2F
	DB &H30, &H31, &H32, &H33, &H34, &H35, &H36, &H37, &H38, &H39, &H3A, &H3B, &H3C, &H3D, &H3E, &H3F
	DB &H40, &H61, &H62, &H63, &H64, &H65, &H66, &H67, &H68, &H69, &H6A, &H6B, &H6C, &H6D, &H6E, &H6F
	DB &H70, &H71, &H72, &H73, &H74, &H75, &H76, &H77, &H78, &H79, &H7A, &H5B, &H5C, &H5D, &H5E, &H5F
	DB &H60, &H61, &H62, &H63, &H64, &H65, &H66, &H67, &H68, &H69, &H6A, &H6B, &H6C, &H6D, &H6E, &H6F
	DB &H70, &H71, &H72, &H73, &H74, &H75, &H76, &H77, &H78, &H79, &H7A, &H7B, &H7C, &H7D, &H7E, &H7F
	DB &H80, &H81, &H82, &H83, &H84, &H85, &H86, &H87, &H88, &H89, &H9A, &H8B, &H9C, &H8D, &H9E, &H8F
	DB &H90, &H91, &H92, &H93, &H94, &H95, &H96, &H97, &H98, &H99, &H9A, &H9B, &H9C, &H9D, &H9E, &HFF
	DB &HA0, &HA1, &HA2, &HA3, &HA4, &HA5, &HA6, &HA7, &HA8, &HA9, &HAA, &HAB, &HAC, &HAD, &HAE, &HAF
	DB &HB0, &HB1, &HB2, &HB3, &HB4, &HB5, &HB6, &HB7, &HB8, &HB9, &HBA, &HBB, &HBC, &HBD, &HBE, &HBF
	DB &HE0, &HE1, &HE2, &HE3, &HE4, &HE5, &HE6, &HE7, &HE8, &HE9, &HEA, &HEB, &HEC, &HED, &HEE, &HEF
	DB &HF0, &HF1, &HF2, &HF3, &HF4, &HF5, &HF6, &HD7, &HF8, &HF9, &HFA, &HFB, &HFC, &HFD, &HFE, &HDF
	DB &HE0, &HE1, &HE2, &HE3, &HE4, &HE5, &HE6, &HE7, &HE8, &HE9, &HEA, &HEB, &HEC, &HED, &HEE, &HEF
	DB &HF0, &HF1, &HF2, &HF3, &HF4, &HF5, &HF6, &HF7, &HF8, &HF9, &HFA, &HFB, &HFC, &HFD, &HFE, &HFF
End AsmData

Function StringHash( value As String, ByVal hashSize As Long ) As Long
	' Case insenstive string hash function
	! MOV ESI, value
	! MOV ESI, [ESI]            ; ESI = StrPtr( value )
	! LEA EBX, LowerCaseBytes   ; Translate table
	! MOV ECX, 1                ; Seed
	! OR ESI, ESI               ; NULL key?
	! JZ StringHash_End
StringHash_Loop:
	! MOVZX EAX, BYTE PTR[ESI]  ; Load byte
	! OR EAX, EAX
	! JZ StringHash_End         ; While @pValue[ i ]
	! XLATB                     ; Lower case version of byte
	! ROL ECX, 3                ; ECX *= 1048576
	! ADD ECX, EAX              ; ECX += @pValue[ i ]
	! INC ESI                   ; Inc i
	! JMP StringHash_Loop       ; Wend
StringHash_End:
	! MOV EBX, hashSize         ; EBX = hashSize
	! MOV EAX, ECX              ; EAX = hc
	! XOR EDX, EDX              ; EDX = 0, forces divident to positive number
	! DIV EBX                   ; EDX:EAX /= hashSize
	! MOV Function, EDX         ; Function = hc Mod hashSize
End Function

Function PtrStriCmp( ByVal aValue As Dword, bValue As String ) As Long
	#Debug Code Off
	' Returns
	'   If a = b then 0
	'   If a < b Then a negative number
	'   If a > b Then a positive number
	! MOV  ESI, aValue          ; ESI = StrPtr( aValue )
	! MOV  EDI, bValue
	! MOV  EDI, [EDI]           ; EDI = StrPtr( bValue )
	! LEA EBX, LowerCaseBytes   ; Translate table
PtrStriCmp_Loop:
	! MOVZX EAX, BYTE PTR[EDI]  ; AL = @b
	! XLATB                     ; AL = LCase$( @b )
	! MOV ECX, EAX              ; ECX = LCase$( @b )
	! MOVZX EAX, BYTE PTR[ESI]  ; EAX = @a
	! XLATB                     ; EAX = LCase$( @a )
	! SUB EAX, ECX              ; res = EAX - ECX
	! JNZ PtrStriCmp_Exit       ; if res<>0 Then Exit
	! OR ECX, ECX               ; If @b = 0
	! JZ SHORT PtrStriCmp_Exit  ; Then Exit
	! INC EDI                   ; Incr b
	! INC ESI                   ; Incr a
	! JMP SHORT PtrStriCmp_Loop ; Wend
PtrStriCmp_Exit:
	! MOV FUNCTION, EAX         ; Function = LCase$( @a ) - LCase$( @b )
	#Debug Code On
End Function

Function StrStrICmp( aValue As String, bValue As String ) As Long
	#Debug Code Off
	' Returns
	'   If a = b then 0
	'   If a < b Then a negative number
	'   If a > b Then a positive number
	! MOV  ESI, aValue
	! MOV  ESI, [ESI]           ; ESI = StrPtr( aValue )
	! MOV  EDI, bValue
	! MOV  EDI, [EDI]           ; EDI = StrPtr( bValue )
	! LEA EBX, LowerCaseBytes   ; Translate table
	! XOR EAX, EAX              ; EAX = 0
StriCmp_Loop:
	! MOV AL, BYTE PTR[EDI]     ; AL = @b
	! XLATB                     ; AL = LCase$( @b )
	! MOV ECX, EAX              ; ECX = LCase$( @b )
	! MOV AL, BYTE PTR[ESI]     ; EAX = @a
	! XLATB                     ; EAX = LCase$( @a )
	! SUB EAX, ECX              ; res = EAX - ECX
	! JNZ StriCmp_Exit          ; if res<>0 Then Exit
	! OR ECX, ECX               ; If @b = 0
	! JZ SHORT StriCmp_Exit     ; Then Exit
	! INC EDI                   ; Incr b
	! INC ESI                   ; Incr a
	! JMP SHORT StriCmp_Loop    ; Wend
StriCmp_Exit:
	! MOV FUNCTION, EAX         ; Function = LCase$( @a ) - LCase$( @b )
	#Debug Code On
End Function

Sub TextReplaceToken( value As String, originalToken As String, newToken As String )
	Local v(), fString As String
	Local i, j, c, e, d, pCol, pType As Long
	Local sp As StringZ Ptr
	Local sb As IStringBuilderA

	If Not init_ Then Call Initialize()

	sb = Class "StringBuilderA"

	c = StrSplit( value, v(), $CrLf )
	d = Len(newToken) - Len( originalToken )

	For i=0 To c-1
		tokenizer_.SetLine( v(i) )
		sb.Clear()
		e = 0
		For j=0 To tokenizer_.Count-1
			Call tokenizer_.GetToken( j, sp, pCol, pType )
			While pCol+e > sb.Len
				sb.Add(" " )
			Wend
			value = @sp
			If StrStrICmp( value, originalToken )=0 Then
				sb.Add( newToken )
				e += d
			Else
				sb.Add( value )
			End If
		Next
		v(i) = sb.String
	Next
	sb = Nothing
	value = Join$( v(), $CrLf )
End Sub

' In-place lower casing of a string (almost 3x faster than lcase$...)
Sub ToLowerPtrA( ByVal a As Dword )
	#Debug Code Off
	Register c As Long
	Local a1 As Byte Ptr
	Local bp As Byte Ptr

	a1 = a
	bp = CodePtr( LowerCaseBytes )
	While @a1[c]
		@a1[c] = @bp[ @a1[c] ]
		Incr c
	Wend
	#Debug Code On
End Sub

Sub ToLowerA( a As String )
	#Debug Code Off
	Call ToLowerPtrA( StrPtr( a ) )
	#Debug Code On
End Sub

Function CompressSignature( value As String ) As String
	Local v(), tvalue As String
	Local i, j, c, p As Long

	c = StrSplit( value, v(), $CrLf )
	For i=c-1 To 0 Step -1
		p = InStr( v(i), " _" )
		If p>0 Then
			v(i) = RTrim$( Left$( v(i), p ) )
		End If
		v(i) = Trim$( v(i) )

		If v(i) = "" Or v(i)="_" Then
			For j=i To c-2
				Swap v(i), v(i+1)
			Next
			Decr c
		End If
	Next
	If c=0 Then
		Function = ""
		Exit Function
	End If
	ReDim Preserve v(c-1)
	tvalue = Join$( v(), " " )
	Replace $Tab With " " In tvalue
	Replace "  " With " " In tvalue
	Replace "  " With " " In tvalue
	Replace " ," With "," In tvalue
	Replace "," With ", " In tvalue
	Replace ",  " With ", " In tvalue
	Replace " (" With "(" In tvalue
	Replace "( " With "(" In tvalue
	Replace " )" With ")" In tvalue
	Replace "( )" With "()" In tvalue
	Replace "  " With " " In tvalue
	Function = tvalue
End Function

Function ExpandTabs( value As String, tabSize As Long ) As String
	Local sb As IStringBuilderA
	Register i As Long
	Local bp As Byte Ptr
	Local tvalue As String

	tvalue = value

	If Not init_ Then Call Initialize()

	sb = Class "StringBuilderA"
	If tabSize<1 Then Function = value: Exit Function

	bp = StrPtr( tvalue )
	For i=0 To Len( tvalue )-1
		If @bp[i]=9 Then
			sb.Add(" ")
			While sb.Len Mod tabSize
				sb.Add(" ")
			Wend
		Else
			sb.Add( Peek$( bp+i, 1 ) )
		End If
	Next
	Function = sb.String
End Function

Function RemoveContinuation( value As String ) As String
	Local v() As String
	Local i, j, k, c, p, cl, tt As Long
	Local bp As Byte Ptr

	c = StrSplit( value, v(), $CrLf )
	For i=c-1 To 0 Step -1
		tokenizer_.SetLine( v(i) )
		For j = 0 To tokenizer_.Count - 1
			tokenizer_.GetToken( j, bp, cl, tt )
			If tt = %TokenTypes.eContinue Then
				v(i) = Left$( v(i), cl )
				v(i) = RTrimWhitespace( v(i) )
				v(i) = Build$( v(i), " ", v(i+1) )
				For k = i+1 To c-2
					Swap v(k), v(k+1)
				Next
				Decr c
				Exit For
			End If
		Next
	Next
	ReDim Preserve v(c-1)
	Function = Join$( v(), $CrLf )
End Function

Function TrimWhitespace( value As String ) As String
	Local l, r As Long
	Local p As Byte Ptr
	Local tvalue As String
	tvalue = value
	p = StrPtr( tvalue )
	While @p[l]=32 Or @p[l]=9
		Incr l
	Wend
	r = Len(tvalue)-1
	While r>l And ( @p[r]=32 Or @p[r]=9 )
		Decr r
	Wend
	If l=<r Then
		Function = Peek$( p+l, r-l+1 )
	End If
End Function

Function RTrimWhitespace( value As String ) As String
	Local r As Long
	Local p As Byte Ptr
	Local tvalue As String
	tvalue = value
	p = StrPtr( tvalue )
	r = Len(tvalue)-1
	While r>-1 And ( @p[r]=32 Or @p[r]=9 )
		Decr r
	Wend
	If r>-1 Then
		Function = Peek$( p, r+1 )
	End If
End Function

Function StrSplit( value As String, list() As String, token As String ) As Long
	Local c As Long
	c = ParseCount( value, token )
	ReDim list(c-1)
	Parse value, list(), token
	Function = c
End Function

Function CheckBlank( value As String ) As Long
	Local bp As Byte Ptr
	Register i As Long
	' Check if value is a blank string ( all characters are less than or equal to a space )

	bp = StrPtr( value )
	' Less likely to have spaces on the right end of string
	For i=Len(value)-1 To 0 Step -1
		If @bp[i]>32 Then Exit Function
	Next
	Function = -1
End Function
