#If %Def( %DEBUG )

Global debug_lastClassInstance As Quad: ' Track instances of objects
Global debug_activeInstances As Long: ' Number of active instances
Global debug_group As String

Macro Debug_SetGroup(grp)
	debug_group = grp
End Macro

Sub Debug_Log( Msg As String )
	Local v As String
	v = msg
	Replace $CrLf With "~" In v
	Trace On
	Trace Print v
	Trace Off
#If %Def( %PB_CC32 )
	Con.Print v
#ElseIf %Def( %PB_Win32 )
	Txt.Print v
#EndIf
End Sub

#If %Def( %REVIEW )
' Review macros
Macro Debug_IsEqual(n,a,b,msg)
	If (a)=(b) Then
		Debug_Log("DBG_TEST "+debug_group+Str$(n)+": " + msg + " {"+Using$("&", a)+"} is not {"+Using$("&", a)+"}")
	End If
End Macro

Macro Debug_IsTrue(n,a,msg)
	If IsTrue (a) Then
		Debug_Log("DBG_TEST "+debug_group+Str$(n)+": "+msg)
	End If
End Macro

Macro Debug_IsFalse(n,a,msg)
	If IsFalse (a) Then
		Debug_Log("DBG_TEST "+debug_group+Str$(n)+": "+msg)
	End If
End Macro

Macro Debug_ClassCreate(msg)
		Incr debug_lastClassInstance
		debug_classInstance_ = debug_lastClassInstance
		Incr debug_activeInstances
		Debug_IsTrue( 0, %LOG_CREATE, msg + ".Create, id=" + Str$(debug_classInstance_) + ", active=" + Str$( debug_activeInstances ) )
End Macro

Macro Debug_ClassDestroy(msg)
		Decr debug_activeInstances
		Debug_IsTrue( 0, %LOG_CREATE, msg + ".Destroy, id=" + Str$(debug_classInstance_) + ", active=" + Str$( debug_activeInstances ) )
End Macro


#Else
' Normal macros
Macro Debug_IsEqual(n,a,b,msg)
	If (a)<>(b) Then
		Debug_Log("DBG_TEST "+debug_group+Format$(n)+": " + msg + " {"+Using$("&", a)+"} is not {"+Using$("&", b)+"}")
	End If
End Macro

Macro Debug_IsTrue(n,a,msg)
	If IsFalse (a) Then
		Debug_Log("DBG_TEST "+debug_group+Format$(n)+": "+msg)
	End If
End Macro

Macro Debug_IsFalse(n,a,msg)
	If IsTrue (a) Then
		Debug_Log("DBG_TEST "+debug_group+Format$(n)+": "+msg)
	End If
End Macro

Macro Debug_ClassCreate(msg)
		Incr debug_lastClassInstance
		debug_classInstance_ = debug_lastClassInstance
		Incr debug_activeInstances
		Debug_IsFalse( 0, %LOG_CREATE, msg + ".Create, id=" + Str$(debug_classInstance_) + ", active=" + Str$( debug_activeInstances ) )
End Macro

Macro Debug_ClassDestroy(msg)
		Decr debug_activeInstances
		Debug_IsFalse( 0, %LOG_CREATE, msg + ".Destroy, id=" + Str$(debug_classInstance_) + ", active=" + Str$( debug_activeInstances ) )
End Macro
#EndIf

Macro Debug_ClassInstance=Instance debug_classInstance_ As Quad

Macro Debug_DefineClassCreate(msg)=Class Method Create(): Debug_ClassCreate(msg): End Method
Macro Debug_DefineClassDestroy(msg)=Class Method Destroy(): Debug_ClassDestroy(msg): End Method

#Else
' Non-Debug macros

Macro Debug_SetGroup(grp)
End Macro

Macro Debug_Log(msg)
End Macro

Macro Debug_IsEqual(n,a,b,msg)
End Macro

Macro Debug_IsTrue(n,a,msg)
End Macro

Macro Debug_IsFalse(n,a,msg)
End Macro

Macro Debug_ClassInstance=#Page

Macro Debug_ClassCreate(msg)
End Macro

Macro Debug_ClassDestroy(msg)
End Macro

Macro Debug_DefineClassCreate(msg)=#Page
Macro Debug_DefineClassDestroy(msg)=#Page

#EndIf
