' Used by cDeclaration (20 bytes/declaration) + size of names (one time)
Type TDecl
	tFileNumber As Integer:   ' File number
	tTokenNumber As Integer:  ' Token number
	tLineNumber As Long:      ' Line number in file
	tNameIndex As Long:       ' Declaration name index
	tDeclType As Long:        ' Type of declaration (Function, Sub, etc) see Enum DeclarationType
	tParent As Long:          ' Class index for interfaces, interface index for props/meths
End Type
' Interesting, but can extract as needed
'  tValueIndex As Long:      ' Name index to declared value, -1 for none
'  tTypeIndex As Long:       ' Declaration name index of the data type (-1 for none)
'  tAttribute As Long:       ' Declaration attributes see DeclAttribute
'  tDispID As Long:          ' Dispatch ID name index , -1 for none
'  tGuidIndex As Long:       ' GUID name index, -1 for none

' Scan for this
'  tEndFileNumber As Integer:   ' File number
'  tEndColumnNumber As Integer: ' Column number
'  tEndLineNumber As Long:      ' Line number in file

' Type of declaration
Enum DeclarationTypes
	eUnknown
	eAsmData        ' Declaration is an AsmData
	eClass          ' Declaration is a class
	eClassMethod    ' Declaration is a class method
	eConstant       ' Declaration is a constant
	eEnum           ' Declaration is am Enum constant
	eField          ' Declaration is a Type or Union field
	eFastProc       ' Declaration is a fast proc
	eFunction       ' Declaration is a function
	eInterface      ' Declaration is an interface
	eLabel          ' Declaration is a label
	eMacroFunction  ' Declaration is a macro function
	eMacro          ' Declaration is a macro
	eMacroTemp      ' Declaration is a Macro Temp
	eMethod         ' Declaration is a method
	eProperty       ' Declaration is a property get
	eReference      ' Declaration is a reference
	eSub            ' Declaration is a sub
	eString         ' Declaration is a String value
	eType           ' Declaration is a type
	eUnion          ' Declaration is a union
	eVariable       ' Declaration is a variable
	eLastType       ' Last entry, all entries should be before this
End Enum

Function GetDeclarationTypeDescription( ByVal tp As Long ) As String
	Select Case Const tp
		Case %DeclarationTypes.eUnknown:         Function = "Unknown"
		Case %DeclarationTypes.eAsmData:         Function = "AsmData"
		Case %DeclarationTypes.eClass:           Function = "Class"
		Case %DeclarationTypes.eClassMethod:     Function = "Class Method"
		Case %DeclarationTypes.eConstant:        Function = "Constant"
		Case %DeclarationTypes.eEnum:            Function = "Enum"
		Case %DeclarationTypes.eField:           Function = "Field"
		Case %DeclarationTypes.eFastProc:        Function = "FastProc"
		Case %DeclarationTypes.eFunction:        Function = "Function"
		Case %DeclarationTypes.eInterface:       Function = "Interface"
		Case %DeclarationTypes.eLabel:           Function = "Label"
		Case %DeclarationTypes.eMacroFunction:   Function = "Macro Function"
		Case %DeclarationTypes.eMacro:           Function = "Macro"
		Case %DeclarationTypes.eMacroTemp:       Function = "MacroTemp"
		Case %DeclarationTypes.eMethod:          Function = "Method"
		Case %DeclarationTypes.eProperty:        Function = "Property"
		Case %DeclarationTypes.eSub:             Function = "Sub"
		Case %DeclarationTypes.eType:            Function = "Type"
		Case %DeclarationTypes.eUnion:           Function = "Union"
		Case %DeclarationTypes.eString:          Function = "String"
		Case %DeclarationTypes.eVariable:        Function = "Variable"
		Case Else:                              Function = "Invalid"
	End Select
End Function

Function GetEndWord( ByVal tp As Long ) As String
	Select Case Const tp
		Case %DeclarationTypes.eAsmData:         Function = "AsmData"
		Case %DeclarationTypes.eClass:           Function = "Class"
		Case %DeclarationTypes.eClassMethod:     Function = "Method"
		Case %DeclarationTypes.eEnum:            Function = "Enum"
		Case %DeclarationTypes.eFastProc:        Function = "FastProc"
		Case %DeclarationTypes.eFunction:        Function = "Function"
		Case %DeclarationTypes.eInterface:       Function = "Interface"
		Case %DeclarationTypes.eMacroFunction:   Function = "Macro"
		Case %DeclarationTypes.eMacro:           Function = "Macro"
		Case %DeclarationTypes.eMethod:          Function = "Method"
		Case %DeclarationTypes.eProperty:        Function = "Property"
		Case %DeclarationTypes.eSub:             Function = "Sub"
		Case %DeclarationTypes.eType:            Function = "Type"
		Case %DeclarationTypes.eUnion:           Function = "Union"
	End Select
End Function

'Enum DeclAttribute Bits
'  eDeclared:    ' Sub/Function
'  eThreadSafe:  ' Sub/Function
'  eCallback:    ' Function
'  eThread:      ' Function
'  eExport:      ' Sub/Function
'  eCommon       ' Sub/Function/Class
'  ePrivate:     ' Sub/Function Default
'
'  eBDecl:       ' Sub/Function
'  eCDecl:       ' Sub/Function
'  eSDecl:       ' Sub/Function Default
'
'  eCom          ' Class/Type
'  eSingular:    ' Type
'  eBits:        ' Type
'
'  eByte:        ' Type Default
'  eWord:        ' Type
'  eDWord:       ' Type
'  eQWord:       ' Type
'
'  eFill:        ' Type
'  eOverride:    ' Property/Method
'
'  eLocal:       ' Default for subs/functions or scope for variable
'  eStatic:      ' subs/functions or scope for variable
'  eGlobal:      ' Variable
'  eInstance:    ' Variable
'  eParameter:   ' Variable
'  eThreaded:    ' Variable
'
'  eEvent:       ' Class/Interface
'  eOptimize:    ' Class
'End Enum

'Function GetAttributePreDescription( ByVal tp As Long, ByVal atr As Long ) As String
'  Local sb As IStringBuilderA
'  sb = Class "StringBuilderA"
'
'  If (tp=%DeclarationTypes.eSub Or _
'      tp=%DeclarationTypes.eFunction ) And _
'      (atr And %DeclAttribute.eDeclared)<>0 _
'  Then sb.Add( "Declare " )
'
'  If tp=%DeclarationTypes.Function And _
'      (atr And %DeclAttribute.eThreadSafe)<>0 _
'  Then sb.Add("ThreadSafe ")
'
'  If tp=%DeclarationTypes.Function And _
'      (atr And %DeclAttribute.eCallback)<>0 _
'  Then sb.Add("CallBack ")
'
'  If tp=%DeclarationTypes.Function And _
'      (atr And %DeclAttribute.eThread)<>0 _
'  Then sb.Add("Thread ")
'
'  If (tp=%DeclarationTypes.eMethod Or _
'      tp=%DeclarationTypes.ePropertyGet Or _
'      tp=%DeclarationTypes.ePropertySet ) And _
'      (atr And %DeclAttribute.eOverride)<>0 _
'  Then sb.Add( "Override " )
'
'  If tp=%DeclarationTypes.eVariable And _
'      (atr And %DeclAttribute.eLocal)<>0 _
'  Then sb.Add( "Local " ): ' Pre Or Post
'
'  If tp=%DeclarationTypes.eVariable And _
'      If (atr And %DeclAttribute.eStatic)<>0 _
'  Then sb.Add( "Static " ): ' Pre Or Post...
'
'  If tp=%DeclarationTypes.eVariable And _
'      (atr And %DeclAttribute.eGlobal)<>0 _
'  Then sb.Add( "Global " )
'
'  If tp=%DeclarationTypes.eVariable And _
'      (atr And %DeclAttribute.eInstance)<>0 _
'  Then sb.Add( "Instance " )
'
'  If tp=%DeclarationTypes.eVariable And _
'      (atr And %DeclAttribute.eThreaded)<>0 _
'  Then sb.Add( "Threaded " )
'
'  Function = sb.String
'  sb = Nothing
'End Function
'
'Function GetAttributePostDescription( ByVal tp As Long, ByVal atr As Long ) As String
'  Local sb As IStringBuilderA
'  sb = Class "StringBuilderA"
'
'  If (tp=%DeclarationTypes.eSub Or _
'    tp=%DeclarationTypes.eFunction) And _
'    (atr And %DeclAttribute.eLocal)<>0 _
'  Then sb.Add( " Local" ): ' Pre/Post
'
'  If (tp=%DeclarationTypes.eSub Or _
'    tp=%DeclarationTypes.eFunction) And _
'    (atr And %DeclAttribute.eStatic)<>0 _
'  Then sb.Add( " Static" ): ' Pre/Post
'
'  If (tp=%DeclarationTypes.eSub Or _
'    tp=%DeclarationTypes.eFunction) And _
'    (atr And %DeclAttribute.eExport)<>0 _
'  Then sb.Add( " Export" )
'
'  If (tp=%DeclarationTypes.eSub Or _
'    tp=%DeclarationTypes.eFunction Or _
'    tp=%DeclarationTypes.eClass) And _
'    (atr And %DeclAttribute.eCommon)<>0 _
'  Then sb.Add( " Common" )
'
'  If (tp=%DeclarationTypes.eSub Or _
'    tp=%DeclarationTypes.eFunction) And _
'    (atr And %DeclAttribute.ePrivate)<>0 _
'  Then sb.Add( " Private" )
'
'  If (tp=%DeclarationTypes.eSub Or _
'    tp=%DeclarationTypes.eFunction) And _
'    (atr And %DeclAttribute.eBDecl)<>0 _
'  Then sb.Add( " BDecl" )
'
'  If (tp=%DeclarationTypes.eSub Or _
'    tp=%DeclarationTypes.eFunction) And _
'    (atr And %DeclAttribute.eCDecl)<>0 _
'  Then sb.Add( " CDecl" )
'
'  If (tp=%DeclarationTypes.eSub Or _
'    tp=%DeclarationTypes.eFunction) And _
'    (atr And %DeclAttribute.eSDecl)<>0 _
'  Then sb.Add( " SDecl" )
'
'  If tp=%DeclarationTypes.eClass And _
'    (atr And %DeclAttribute.eCom)<>0 _
'  Then sb.Add( " As Com" )
'
'  If tp=%DeclarationTypes.eType And _
'    (atr And %DeclAttribute.eSingular)<>0 _
'  Then sb.Add( " Singular" )
'
'  If tp=%DeclarationTypes.eType And _
'    (atr And %DeclAttribute.eBits)<>0 _
'  Then sb.Add( " Bits" )
'
'  If tp=%DeclarationTypes.eType And _
'    (atr And %DeclAttribute.eByte)<>0 _
'  Then sb.Add( " Byte" )
'
'  If tp=%DeclarationTypes.eType And _
'    (atr And %DeclAttribute.eWord)<>0 _
'  Then sb.Add( " Word" )
'
'  If tp=%DeclarationTypes.eType And _
'    (atr And %DeclAttribute.eDWord)<>0 _
'  Then sb.Add( " DWord" )
'
'  If tp=%DeclarationTypes.eType And _
'    (atr And %DeclAttribute.eQWord)<>0 _
'  Then sb.Add( " QWord" )
'
'  If tp=%DeclarationTypes.eType And _
'    (atr And %DeclAttribute.eFill)<>0 _
'  Then sb.Add( " Fill" )
'
'  If (tp=%DeclarationTypes.eMethod Or _
'    tp=%DeclarationTypes.ePropertyGet Or _
'    tp=%DeclarationTypes.ePropertySet) And _
'    (atr And %DeclAttribute.eOverride)<>0 _
'  Then sb.Add( " Override" )
'
'  If (tp=%DeclarationTypes.eClass Or _
'    tp=%DeclarationTypes.eInterface) And _
'    (atr And %DeclAttribute.eEvent)<>0 _
'  Then sb.Add( " As Event" )
'
'  If tp=%DeclarationTypes.eClass And _
'    (atr And %DeclAttribute.eOptimize)<>0 _
'  Then sb.Add( " Optimize" )
'
'  Function = sb.String
'  sb = Nothing
' End Function
