Enum TokenTypes
	eUnknown     ' Unknown token (should never happen)
	eAsm         ' Token contains assembler statement
	eKeyword     ' Token is a built in
	eContinue    ' Token is the _
	eConstant    ' Token is a contant
	eIdentifier  ' Token is an identifier
	eNumber      ' Token is a number
	eOperator    ' Token is an operator
	eRemark      ' Token is a remark
	eString      ' Token is a string
End Enum

Function GetTokenTypeDescription( ByVal tt As Long ) As String
	Select Case Const tt
		Case %TokenTypes.eAsm:        Function = "Asm"
		Case %TokenTypes.eKeyword:    Function = "Keyword"
		Case %TokenTypes.eContinue:   Function = "Continue"
		Case %TokenTypes.eConstant:   Function = "Constant"
		Case %TokenTypes.eIdentifier: Function = "Identifier"
		Case %TokenTypes.eNumber:     Function = "Number"
		Case %TokenTypes.eOperator:   Function = "Operator"
		Case %TokenTypes.eRemark:     Function = "Remark"
		Case %TokenTypes.eString:     Function = "String"
		Case Else:                    Function = "Unknown"
	End Select
End Function
