Sub DeclareTests()
	Local value As String
	Local constants, interfaces, classes As String
	Local sf As iSourceFile
	Local st, en As Long

	Call NewSourceFile( sf, "", 0 )

	Open $DECLARE_FILE For Binary As #1
	Get$ #1, Lof(#1), value
	Close #1

	Local hWin As Dword
	Call pbsSnippetNew( "test" )
	pbsSnippetSetText( value )
	Call pbsSnippetDeclareScan( -1 )

	Local i As Long
	Local decl As TDecl
#If %Def( %PB_CC32 )
	Con.Color( 8, -1 )
	Con.Cls
#ElseIf %Def( %PB_Win32 )
	Txt.Color = RGB(0,0,0)
	Txt.Cls
#EndIf

	Do
		en = Min&( st+19, pbsSnippetDeclareGetCount()-1 )
		value = Format$( st, "0" ) + "-" + Format$( en, "0" )
#If %Def( %PB_CC32 )
		Con.Print ""
		Con.Print "Which declare? (L=List ( ";value;"), N=Next 10, P=Prior 10 [exit] ";
		Con.Line.Input value
#ElseIf %Def( %PB_Win32 )
		Txt.Print ""
		Txt.Print "Which declare? (L=List ( ";value;"), N=Next 10, P=Prior 10 [exit] ";
		Txt.Line.Input value
#EndIf
		If value="" Then exitMessage="exit": Exit Sub
#If %Def( %PB_CC32 )
		Con.Cls
#ElseIf %Def( %PB_Win32 )
		Txt.Cls
#EndIf
		Select Case LCase$( Left$( value,1) )
			Case "l","n","p"
				Select Case LCase$( Left$( value,1) )
					Case "n": If st+20 < pbsSnippetDeclareGetCount() Then st+=20
					Case "p": If st-20 >= 0 Then st-=20
				End Select
				en = Min&( st+19, pbsSnippetDeclareGetCount()-1 )

				For i=st To en
					Call pbsSnippetDeclareItem( i, decl )
					value = pbsSnippetDeclareGetName( decl.tNameIndex )
#If %Def( %PB_CC32 )
					Con.Print Format$(i, "00");") "; Left$( value + Repeat$(25, "."), 25 ); " "; GetDeclarationTypeDescription( decl.tDeclType )
#ElseIf %Def( %PB_Win32 )
					Txt.Print Format$(i, "00");") "; Left$( value + Repeat$(25, "."), 25 ); " "; GetDeclarationTypeDescription( decl.tDeclType )
#EndIf
				Next
				Iterate Loop
		End Select
		i = Val( value )
		If i<0 Or i>=pbsSnippetDeclareGetCount() Then Iterate Loop

		Call pbsSnippetDeclareItem( i, decl )
		value = pbsSnippetDeclareGetName( decl.tNameIndex )
#If %Def( %PB_CC32 )
		Con.Print Format$(i, "0");") ";value; " is a "; GetDeclarationTypeDescription( decl.tDeclType ); " @ ("; Format$(decl.tLineNumber, "0"); ", "; Format$(decl.tTokenNumber, "0"); ")"
#ElseIf %Def( %PB_Win32 )
		Txt.Print Format$(i, "0");") ";value; " is a "; GetDeclarationTypeDescription( decl.tDeclType ); " @ ("; Format$(decl.tLineNumber, "0"); ", "; Format$(decl.tTokenNumber, "0"); ")"
#EndIf
		Local j, c As Long
		Local lines_() As String

		value = snippetDeclares_.GetSignature( i )
		Call ShowList("Signature:", value, -1 )

		value = CompressSignature( value )
		Call ShowList( "Compressed signature:", value, -1 )

		value = snippetDeclares_.GetDefinition( i )
		j = IIf&( decl.tDeclType=%DeclarationTypes.eInterface And decl.tParent=-1,0,-1)
		value = RemoveContinuation( value )
		sf.Text = value
		indenter_.Indent( sf, j )
		value = sf.Text
		c = StrSplit( value, lines_(), $CrLf )

		For j=0 To c-1
			lines_( j ) = ExpandTabs( lines_( j ), 2 )
		Next
		Call ShowList( "Definition:", Join$( lines_(), $CrLf ), -1 )

		If decl.tParent>-1 Then
			Local list() As String
			Local decl2 As TDecl
			Local k, pIndex As Long
			ReDim list(10)
			pIndex = decl.tParent
			k = 0
			While pIndex >-1
				Call pbsSnippetDeclareItem( pIndex, decl2 )
				list(k) = pbsSnippetDeclareGetName( decl2.tNameIndex ) + ": " + GetDeclarationTypeDescription( decl2.tDeclType )
				pIndex = decl2.tParent
				Incr k
			Wend
			ReDim Preserve list(k-1)

			Call ShowList( "Parents:", Join$( list(), $CrLf ), -1 )
		End If

		If decl.tDeclType = %DeclarationTypes.eClass Then
			Call ShowList("Class outline:", snippetDeclares_.GetClassOutline( i ), -1 )
			Call ShowList("Class interfaces:", snippetDeclares_.GetClassInterfaces( i ), -1 )
			Call ShowList("Class instance variables:", snippetDeclares_.GetInstanceVariables( i ), -1 )
			Call ShowList("Class methods:", snippetDeclares_.GetClassMethods( i ), -1 )
		End If
		If decl.tDeclType = %DeclarationTypes.eInterface Then
			interfaces = snippetDeclares_.GetInterfaceDeclaration( i, constants )
			value = pbsSnippetDeclareGetName( decl.tNameIndex )
			classes = snippetDeclares_.GetInterfaceClasses( value )
			Call ShowList("Interface constants:", constants, -1 )
			Call ShowList("Interface declaration:", interfaces, -1 )
			Call ShowList("Interface classes:", classes, -1 )
		End If
	Loop
End Sub
