
Function GetValue( filename As String ) As String
	' Gets the contents of a file.
	Local value As String
	Open filename For Binary As #1
	Get$ #1, Lof(#1), value
	Close #1
	Function = value
End Function

Sub ShowList( title As String, value As String, Optional ByVal doPause As Long )
	' Outputs a Cr/Lf delimeted string on the
	' console with a title above it.
	Local j, c As Long
	Local lines_() As String
	Local a As String

	c = StrSplit( value, lines_(), $CrLf )
#If %Def( %PB_CC32 )
	Con.Color( 3, -1 )
	Con.Print
	Con.Print title
	Con.Color( 8, -1 )
#ElseIf %Def( %PB_Win32 )
	Txt.Cls
	Txt.Color = RGB( 0, 128, 192 )
	Txt.Print title
	Txt.Color = RGB( 0, 0, 0 )
#EndIf
	For j=0 To c-1
		PRNT("    "+lines_( j ) )
	Next
#If %Def( %PB_Win32 )
	If doPause Then
		Txt.Print "Press ENTER to continue"
		Txt.Line.Input a
	End If
#EndIf
End Sub

Sub PrintList( value As String )
	Local j, c As Long
	Local lines_() As String

	c = StrSplit( value, lines_(), $CrLf )
	For j=0 To c-1
		PRNT(lines_( j ) )
	Next
End Sub

Sub DoCleanup()
	' Clean up from last run.  It does this by
	' generating a batch file and then running it.
	' the batch file will have all the correct
	' paths based on where you compiled this.
	basePath = Exe.Path$
	If Right$( basePath, 1 )<>"\" Then basePath+="\"
	Open basePath + "clean.cmd" For Output As #1
	Print #1, "@Echo Off"
	Print #1, "f:"
	Print #1, "cd " + Wrap$( basePath, $Dq, $Dq )
	Print #1, RemoveDirectory( "TestProject2" )
	Print #1, RemoveDirectory( "TestProject3" )
	Print #1, RemoveDirectory( "TestFile" )
	Print #1, RemoveDirectory( "TestFileSys1" )
	Print #1, RemoveDirectory( "TestFileSys2" )
	Print #1, RemoveDirectory( "TestFileSys3" )
	Print #1, RemoveDirectory( "TestSnippet" )
	Print #1, "Del config\test.builtin"
	Close #1
	Shell "cmd /c " + Wrap$( basePath + "clean.cmd", $Dq, $Dq ), 0
End Sub

Function RemoveDirectory( value As String ) As String
	Function = Build$( "IF EXIST ", value, " rd /s /q ", value )
End Function

Function GroupTestName( value As String ) As String
	Local n As String
	Local p As Long

	n = value
	p = InStr( n, "_" )
	If p>0 Then n = Left$( n, p-1)
	Function = MCase$(n)
End Function
