Sub FileTests()
	Local i, c As Long
	Local value, value2 As String

	pbsKeywordLoad( "pbwin10" )

	Debug_SetGroup("File")
	Debug_Log("")
	Debug_Log("============================================")
	Debug_Log("File")
	Debug_Log("--------------------------------------------")

	' Ensure TestFile is setup, Copy TestProject\Test.bas project to TestFile
	Shell( "cmd /c " + RemoveDirectory( "TestFile" ), 0 )
	Call pbsProjectSetIncludePaths( basePath + "TestProject" )       ' Need to ensure we can load the project
	Call pbsProjectLoad( basePath + "testproject\test.bas" )
	Debug_IsEqual(   1, pbsProjectFileCount(), 6, "FileCount" )
	Call pbsProjectSetBasePath( basePath + "TestFile\" )
	Call pbsProjectSave()
	Call pbsProjectClose()

	'=================================================================
	Call pbsProjectSetIncludePaths( basePath + "TestFile\" )         ' Need to ensure we can load the project
	Call pbsFileLoad( basePath + "TestFile\test.bas" )
	c = pbsProjectFileCount()
	Debug_IsEqual(   2, c, 1, "FileCount" )

	Call pbsFileNew( basePath + "TestFile\test2.inc" ):             ' Should fail, file exists
	c = pbsProjectFileCount()

	Debug_IsEqual(   3, c, 1, "FileCount" ): '

	Call pbsFileNew( basePath + "TestFile\test2.inc", -1 ):          ' Should succeed, overwrites file
	c = pbsProjectFileCount()
	Debug_IsEqual(   4, c, 2, "FileCount" ): '

	Debug_IsEqual(   5, pbsFileByteSize(), 0, "Size in bytes" )

	'=================================================================
	i = pbsFileIndexFilename( basePath + "TestFile\test.bas" )
	pbsFileActivate( i )
	Debug_IsEqual(   6, i, 0, "FileNumber" )

	i = pbsFileIndexFilename( basePath + "TestFile\test2.inc" )
	pbsFileActivate( i )

	c = pbsFileGetLineCount()
	Debug_IsEqual(   7, c, 1, "LineCount" )
	'=================================================================
	pbsFileAddText( Build$("'Line 1", $CrLf, "'Line 2", $CrLf, "'Line 3" ) )
	c = pbsFileGetLineCount()
	Debug_IsEqual(   8, c, 4, "LineCount" )

	Debug_IsEqual(   9, pbsFileByteSize(), 27, "Size in bytes" )


	value = pbsFileGetLine( 1 )
	Debug_IsEqual(  10, value, "'Line 1", "Line 1" )

	value = pbsFileGetLine( 2 )
	Debug_IsEqual(  11, value, "'Line 2", "Line 2" )

	value = pbsFileGetLine( 3 )
	Debug_IsEqual(  12, value, "'Line 3", "Line 3" )

	'=================================================================
	pbsFileInsertText( 1, Build$( "'New line 1", $CrLf, "'New line 2", $CrLf, "'New line 3" ) )
	c = pbsFileGetLineCount()
	Debug_IsEqual(  13, c, 7, "LineCount" )

	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  14, value, "", "Line 0"  )

	value = pbsFileGetLine( 1 )
	Debug_IsEqual(  15, value, "'New line 1", "Line 1" )

	value = pbsFileGetLine( 2 )
	Debug_IsEqual(  16, value, "'New line 2", "Line 2"  )

	value = pbsFileGetLine( 3 )
	Debug_IsEqual(  17, value, "'New line 3", "Line 3"  )

	value = pbsFileGetLine( 4 )
	Debug_IsEqual(  18, value, "'Line 1", "Line 4"  )

	value = pbsFileGetLine( 5 )
	Debug_IsEqual(  19, value, "'Line 2", "Line 5"  )

	value = pbsFileGetLine( 6 )
	Debug_IsEqual(  20, value, "'Line 3", "Line 6"  )

	'=================================================================
	pbsFileDeleteText( 4, 3 )
	c = pbsFileGetLineCount()
	Debug_IsEqual(  21, c, 4, "LineCount" )

	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  22, value, "", "Line 0" )

	value = pbsFileGetLine( 1 )
	Debug_IsEqual(  23, value, "'New line 1", "Line 1" )

	value = pbsFileGetLine( 2 )
	Debug_IsEqual(  24, value, "'New line 2", "Line 2" )

	value = pbsFileGetLine( 3 )
	Debug_IsEqual(  25, value, "'New line 3", "Line 3" )

	'=================================================================
	pbsFileDeleteText( 0, 1 )
	c = pbsFileGetLineCount()
	Debug_IsEqual(  26, c, 3, "LineCount" )

	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  27, value, "'New line 1", "Line 0" )

	value = pbsFileGetLine( 1 )
	Debug_IsEqual(  28, value, "'New line 2", "Line 1" )

	value = pbsFileGetLine( 2 )
	Debug_IsEqual(  29, value, "'New line 3", "Line 2" )


	'=================================================================
	pbsFileDeleteText( 1, 1 )
	c = pbsFileGetLineCount()
	Debug_IsEqual(  30, c, 2, "LineCount" )

	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  31, value, "'New line 1", "Line 0" )

	value = pbsFileGetLine( 1 )
	Debug_IsEqual(  32, value, "'New line 3", "Line 1" )

	'=================================================================
	pbsFileDeleteText( 1, 2 )
	c = pbsFileGetLineCount()
	Debug_IsEqual(  33, c, 1, "LineCount" )

	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  34, value, "'New line 1", "Line 0" )

	'=================================================================
	pbsFileDeleteText( 0, 1 )
	c = pbsFileGetLineCount()
	Debug_IsEqual(  35, c, 0, "LineCount" )

	'=================================================================
	pbsFileDeleteText( 4, 1 )
	c = pbsFileGetLineCount()
	Debug_IsEqual(  36, c, 0, "LineCount" )

	'=================================================================
	pbsFileInsertText( 0, Build$( "'New line 1", $CrLf, "'New line 2", $CrLf, "'New line 3" ) )
	c = pbsFileGetLineCount()
	Debug_IsEqual(  37, c, 3, "LineCount" )

	'=================================================================
	pbsFileReplaceText( 1, 1, Build$( "'A", $CrLf, "'B", $CrLf, "'C" ) )
	c = pbsFileGetLineCount()
	Debug_IsEqual(  38, c, 5, "LineCount" )

	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  39, value, "'New line 1", "Line 0" )

	value = pbsFileGetLine( 1 )
	Debug_IsEqual(  40, value, "'A", "Line 1" )

	value = pbsFileGetLine( 2 )
	Debug_IsEqual(  41, value, "'B", "Line 2" )

	value = pbsFileGetLine( 3 )
	Debug_IsEqual(  42, value, "'C", "Line 3" )

	value = pbsFileGetLine( 4 )
	Debug_IsEqual(  43, value, "'New line 3", "Line 4" )

	'=================================================================
	pbsFileReplaceText( 1, 3, "'New line 2" )
	c = pbsFileGetLineCount()
	Debug_IsEqual(  44, c, 3, "LineCount" )

	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  45, value, "'New line 1", "Line 0" )

	value = pbsFileGetLine( 1 )
	Debug_IsEqual(  46, value, "'New line 2", "Line 1" )

	value = pbsFileGetLine( 2 )
	Debug_IsEqual(  47, value, "'New line 3", "Line 2" )

	pbsFileSetLine( 0, "'Test line 1" )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  48, value, "'Test line 1", "Line 0" )

	'=================================================================
	pbsProjectSave()
	pbsProjectClose()
	Call pbsFileLoad( basePath + "TestFile\test2.inc" )
	'=================================================================

	c = pbsFileGetLineCount()
	Debug_IsEqual(  49, c, 3, "LineCount" )

	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  50, value, "'Test line 1", "Line 0" )

	value = pbsFileGetLine( 1 )
	Debug_IsEqual(  51, value, "'New line 2", "Line 1" )

	value = pbsFileGetLine( 2 )
	Debug_IsEqual(  52, value, "'New line 3", "Line 2" )
	'=================================================================

	pbsFileSetLine( 0, "'New line 1" )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  53, value, "'New line 1", "Line 0" )

	pbsFileReload()

	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  54, value, "'Test line 1", "Line 0" )
	'=================================================================

	pbsFileSetLine( 0, "'New line 1" )
	pbsFileSave()
	pbsProjectClose()
	Call pbsFileLoad( basePath + "TestFile\test2.inc" )
	pbsFileActivate( 0 )
	c = pbsFileGetLineCount()
	Debug_IsEqual(  55, c, 3, "LineCount" )

	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  56, value, "'New line 1", "Line 0" )
	'=================================================================

	value = pbsFileGetFilename()
	Debug_IsEqual(  57, LCase$(value), LCase$( basePath + "TestFile\test2.inc" ), "Filename" )

	value = pbsFileShortname( value )
	Debug_IsEqual(  58, LCase$(value), LCase$( "test2.inc" ), "Filename" )

	'=================================================================
	value = pbsFileGetLines( 0, 1 )
	Debug_IsEqual(  59, value, Build$("'New line 1"), "GetLines" )

	value = pbsFileGetLines( 0, 2 )
	Debug_IsEqual(  60, value, Build$("'New line 1", $CrLf, "'New line 2" ), "GetLines" )

	value = pbsFileGetLines( 0, 3 )
	Debug_IsEqual(  61, value, Build$("'New line 1", $CrLf, "'New line 2", $CrLf, "'New line 3" ), "GetLines" )

	value = pbsFileGetLines( 0, 4 )
	Debug_IsEqual(  62, value, Build$("'New line 1", $CrLf, "'New line 2", $CrLf, "'New line 3" ), "GetLines" )

	value = pbsFileGetLines( 1, 1 )
	Debug_IsEqual(  63, value, Build$("'New line 2" ), "GetLines" )

	value = pbsFileGetLines( 1, 2 )
	Debug_IsEqual(  64, value, Build$( "'New line 2", $CrLf, "'New line 3" ), "GetLines" )

	value = pbsFileGetLines( 1, 3 )
	Debug_IsEqual(  65, value, Build$( "'New line 2", $CrLf, "'New line 3" ), "GetLines" )

	value = pbsFileGetLines( 2, 1 )
	Debug_IsEqual(  66, value, Build$( "'New line 3" ), "GetLines" )

	value = pbsFileGetLines( 2, 2 )
	Debug_IsEqual(  67, value, Build$( "'New line 3" ), "GetLines" )

	value = pbsFileGetLines( 3, 1 )
	Debug_IsEqual(  68, value, "", "GetLines" )

	'=================================================================
	c = pbsProjectFileCount()
	Debug_IsEqual(  69, c, 1, "ProjectFileCount" )

	Call pbsFileNew( "test3.inc", -1 )
	c = pbsProjectFileCount()
	Debug_IsEqual(  70, c, 2, "ProjectFileCount" )

	pbsProjectSave()

	c = pbsProjectFileCount()
	Debug_IsEqual(  71, c, 2, "ProjectFileCount" )

	i = pbsFileIndexFilename( "test3.inc" )
	pbsFileClose( i )

	c = pbsProjectFileCount()
	Debug_IsEqual(  72, c, 1, "ProjectFileCount" )

	c = pbsProjectHasFile( "test2.inc" )
	Debug_IsEqual(  73, c, -1, "ProjectHasFile" )

	c = pbsProjectHasFile( "test3.inc" )
	Debug_IsEqual(  74, c, 0, "ProjectHasFile" )

	'=================================================================
	Local values() As String

	i = pbsFileIndexFilename( "test2.inc" )
	pbsFileActivate( i )
	pbsFileGetTextArray( 0, 1, values() )
	Debug_IsEqual(  75, UBound( values() ), 0, "UBound" )
	Debug_IsEqual(  76, values(0), "'New line 1", "GetLines" )

	'=================================================================
	pbsFileGetTextArray( 0, 3, values() )
	Debug_IsEqual(  77, UBound( values() ), 2, "UBound" )
	Debug_IsEqual(  78, values(0), "'New line 1", "GetLines" )
	Debug_IsEqual(  79, values(1), "'New line 2", "GetLines" )
	Debug_IsEqual(  80, values(2), "'New line 3", "GetLines" )


	'=================================================================
	pbsFileGetTextArray( -1, 2, values() )
	Debug_IsEqual(  81, UBound( values() ), 0, "UBound" )
	Debug_IsEqual(  82, values(0), "'New line 1", "GetLines" )

	'=================================================================
	pbsFileGetTextArray( 2, 2, values() )
	Debug_IsEqual(  83, UBound( values() ), 0, "UBound" )
	Debug_IsEqual(  84, values(0), "'New line 3", "GetLines" )

	'=================================================================
	pbsFileSetLine( 0, "Tst" )
	pbsFileInsertChars( 0, 1, "e" )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  85, value, "Test", "InsertChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileInsertChars( 0, 0, "A " )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  86, value, "A Test", "InsertChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileInsertChars( 0, -1, "A " )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  87, value, "Test", "InsertChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileInsertChars( 0, 5, " for sure" )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  88, value, "Test", "InsertChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileInsertChars( 0, 4, " for sure" )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  89, value, "Test for sure", "InsertChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileDeleteChars( 0, 1, 1 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  90, value, "Tst", "DeleteChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileDeleteChars( 0, 0, 1 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  91, value, "est", "DeleteChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileDeleteChars( 0, -1, 1 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  92, value, "Test", "DeleteChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileDeleteChars( 0, 4, 2 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  93, value, "Test", "DeleteChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileDeleteChars( 0, 3, 2 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  94, value, "Tes", "DeleteChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileDeleteChars( 0, 1, 2 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  95, value, "Tt", "DeleteChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileDeleteChars( 0, 1, 4 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  96, value, "T", "DeleteChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileReplaceChars( 0, 1, 4, "rust" )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  97, value, "Trust", "ReplaceChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileReplaceChars( 0, 0, 1, "B" )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  98, value, "Best", "ReplaceChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileReplaceChars( 0, -1, 1, "B" )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual(  99, value, "Test", "ReplaceChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileReplaceChars( 0, 4, 1, "B" )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual( 100, value, "TestB", "ReplaceChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileReplaceChars( 0, 5, 1, "B" )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual( 101, value, "Test", "ReplaceChars" )

	'=================================================================
	pbsFileSetLine( 0, "Test" )
	pbsFileReplaceChars( 0, 3, 1, "ting" )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual( 102, value, "Testing", "ReplaceChars" )

	'=================================================================
	pbsFileSetLine( 0, Build$( $Tab, $Tab, "Test" ) )
	pbsProjectSetTabSize( 0 )
	pbsFileExpandTabs( 0 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual( 103, value, Build$( $Tab, $Tab, "Test" ), "ExpandTabs" )

	'=================================================================
	pbsFileSetLine( 0, Build$( $Tab, $Tab, "Test" ) )
	pbsFileExpandTabs( 1 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual( 104, value, "  Test", "ExpandTabs" )

	'=================================================================
	pbsFileSetLine( 0, Build$( $Tab, $Tab, "Test" ) )
	pbsFileExpandTabs( 2 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual( 105, value, "    Test", "ExpandTabs" )

	'=================================================================
	pbsFileSetLine( 0, Build$( $Tab, $Tab, "Test" ) )
	pbsFileExpandTabs( 3 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual( 106, value, "      Test", "ExpandTabs" )

	'=================================================================
	pbsFileSetLine( 0, Build$( $Tab, $Tab, "Test" ) )
	pbsFileExpandTabs( 4 )
	value = pbsFileGetLine( 0 )
	Debug_IsEqual( 107, value, "        Test", "ExpandTabs" )

	'=================================================================
	pbsFileSetText( "" )
	value = pbsFileGetText()
	Debug_IsEqual( 108, value, "", "GetText" )

	'=================================================================
	pbsFileSetText( Build$( "Test", $CrLf ) )
	value = pbsFileGetText()
	Debug_IsEqual( 109, value, Build$( "Test", $CrLf ), "GetText" )

	'=================================================================
	pbsFileSetText( Build$( "Test", $CrLf, "Test2", $CrLf ) )
	value = pbsFileGetText()
	Debug_IsEqual( 110, value, Build$( "Test", $CrLf, "Test2", $CrLf ), "GetText" )

	'=================================================================
	pbsFileSetText( Build$( "Test", $CrLf, "Test2" ) )
	value = pbsFileGetText()
	Debug_IsEqual( 111, value, Build$( "Test", $CrLf, "Test2"), "GetText" )

	'=================================================================
	Call pbsFileLoad( basePath + "TestProject\testIndented.bas" )
	value = pbsFileGetText()
	Call pbsFileLoad( basePath + "TestProject\testindent.bas" )
	pbsFileIndent()
	pbsFileSetIsExternal(0)
	pbsFileSave()
	Debug_IsEqual( 112, value, pbsFileGetText(), "Indent" )


	'=================================================================
	pbsProjectClose()
	Call pbsFileLoad( basePath + "TestProject\testindent.bas" )
	pbsFileSetFilename( basePath + "TestProject\testindent2.bas" )
	value = pbsFileGetFilename()
	Debug_IsEqual( 113, value, basePath + "TestProject\testindent2.bas", "SetFilename" )
	pbsFileSave()

	'=================================================================
	pbsProjectClose()
	Call pbsFileNew( basePath + "TestFile\testLines.bas" ):             ' Should fail, file exists
	Debug_IsEqual( 114, pbsFileGetLineCount(), 1, "GetLineCount" )
	pbsFileSetLineCount( 5 )
	Debug_IsEqual( 115, pbsFileGetLineCount(), 5, "SetLineCount" )


	'=================================================================
	pbsProjectClose()
	Call pbsFileNew( basePath + "TestFile\testLines.bas", -1 ):             ' Overwrite
	Debug_IsEqual( 116, pbsFilenameIsExternal(basePath + "TestFile\testLines.bas"), 0, "IsExternal" ):         ' Internal
	Debug_IsEqual( 117, pbsFilenameIsExternal( basePath + "TestProject\testindent2.bas" ), -1, "IsExternal" ):        ' External

	'=================================================================
	pbsProjectClose()
	Call pbsFileNew( basePath + "TestFile\testspace.bas", -1 ):             ' Overwrite
	pbsFileSetText( Build$( "  one  ", $CrLf, "  two  three  ") )
	pbsFileTrimWhitespace()
	value = pbsFileGetText()
	Debug_IsEqual( 118, Build$( "one",$CrLf,"two  three"), value, "TrimWhitepace" )

	'=================================================================
	pbsFileSetText( "one One ONE oNe OnE ONe oNE for FOR For fOr FoR" )
	pbsFileCasedText( 0, %KeywordCase.Original, 0 )
	value = pbsFileGetText()
	Debug_IsEqual( 119, "one One ONE oNe OnE ONe oNE for FOR For fOr FoR", value, "StandarizeCase" )

	'=================================================================
	pbsFileSetText( "one One ONE oNe OnE ONe oNE for FOR For fOr FoR" )
	pbsFileCasedText( 0, %KeywordCase.Lower, 0 )
	value = pbsFileGetText()
	Debug_IsEqual( 120, "one One ONE oNe OnE ONe oNE for for for for for", value, "StandarizeCase" )

	'=================================================================
	pbsFileSetText( "one One ONE oNe OnE ONe oNE for FOR For fOr FoR" )
	pbsFileCasedText( 0, %KeywordCase.Upper, 0 )
	value = pbsFileGetText()
	Debug_IsEqual( 121, "one One ONE oNe OnE ONe oNE FOR FOR FOR FOR FOR", value, "StandarizeCase" )

	'=================================================================
	pbsFileSetText( "one One ONE oNe OnE ONe oNE for FOR For fOr FoR" )
	pbsFileCasedText( 0, %KeywordCase.Mixed, 0 )
	value = pbsFileGetText()
	Debug_IsEqual( 122, "one One ONE oNe OnE ONe oNE For For For For For", value, "StandarizeCase" )

	'=================================================================
	pbsFileSetText( "one One ONE oNe OnE ONe oNE for FOR For fOr FoR" )
	pbsFileCasedText( 0, %KeywordCase.Original, -1 )
	value = pbsFileGetText()
	Debug_IsEqual( 123, "one one one one one one one for FOR For fOr FoR", value, "StandarizeCase" )

	'=================================================================
	pbsFileSetText( "One one ONE oNe OnE ONe oNE for FOR For fOr FoR" )
	pbsFileCasedText( 0, %KeywordCase.Original, -1 )
	value = pbsFileGetText()
	Debug_IsEqual( 124, "One One One One One One One for FOR For fOr FoR", value, "StandarizeCase" )

	'=================================================================
	pbsFileSetText( "ONE one One oNe OnE ONe oNE for FOR For fOr FoR" )
	pbsFileCasedText( 0, %KeywordCase.Original, -1 )
	value = pbsFileGetText()
	Debug_IsEqual( 125, "ONE ONE ONE ONE ONE ONE ONE for FOR For fOr FoR", value, "StandarizeCase" )

	'=================================================================
	pbsProjectClose()
	pbsFileLoad( basePath + "TestProject\TestIndent.bas" )
	pbsFileRemoveContinuation()
	pbsFileManageBlankLines()
	value = pbsFileGetText()
	'pbsFileSave( basePath + "TestProject\TestIndentManged.bas" )
	pbsFileLoad( basePath + "TestProject\TestIndentManged.bas" )
	Local bb As String
	bb = pbsFileGetText()
	Debug_IsEqual( 126, value, bb, "Managed" )

	'=================================================================
	pbsProjectClose()
	pbsFileLoad( basePath + "TestProject\TestIndent.bas" )
	pbsFileRemoveContinuation()
	pbsFileManageBlankLines()
	pbsFileIndent()
	'                                                 single
	'                       tab  Keyword casing         case  mono color
	value = pbsFileToBBCode(  2, %KeywordCase.Original,   -1,   -1,   -1 )
'  Clipboard Reset
'  Clipboard Set Text value
	pbsFileLoad( basePath + "TestProject\TestIndent.bbcode" )
	Debug_IsEqual( 127, value, pbsFileGetText(), "BBCode" )

	'=================================================================
	pbsProjectClose()
	pbsFileLoad( basePath + "TestProject\TestIndent.bas" )
	pbsFileRemoveContinuation()
	pbsFileManageBlankLines()
	'                                               single
	'                     tab  Keyword casing         case  mono color
	value = pbsFileToHtml(  2, %KeywordCase.Original,   -1,   -1,   -1 )
'  Clipboard Reset
'  Clipboard Set Text value
	pbsFileLoad( basePath + "TestProject\TestIndent.html" )
	Debug_IsEqual( 128, value, pbsFileGetText(), "Html" )

	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestFile\TestToken.bas" )
	pbsFileSetText( Build$( "one", $CrLf, " ONE", $CrLf, "this is One test" ) )
	pbsFileReplaceToken( "one", "two" )
	value = pbsFileGetText()
	Debug_IsEqual( 129, value, Build$( "two", $CrLf, " two", $CrLf, "this is two test" ), "ReplaceToken" )

	'=================================================================
	pbsProjectClose()
	pbsFileNew( basePath + "TestFile\TestToken.bas" )
	pbsFileSetText( Build$( "one", $CrLf, " ONE", $CrLf, "this is One test" ) )
	pbsFileInsertClass( 1, "cTest", 0 )
	value = pbsFileGetText()
	value2 = Build$(  "one", $CrLf, _
										"Class cTest", $CrLf, _
										"End Class", $CrLf, _
										" ONE", $CrLf, _
										"this is One test" )
	Debug_IsEqual( 130, value, value2, "InsertClass" )
	pbsFileInsertInterface( 2, "iTest", "IUnknown", 0 )
	value = pbsFileGetText()
	value2 = Build$(  "one", $CrLf, _
										"Class cTest", $CrLf, _
										"  Interface iTest", $CrLf, _
										"    Inherit IUnknown", $CrLf, _
										"  End Interface", $CrLf, _
										"End Class", $CrLf, _
										" ONE", $CrLf, _
										"this is One test" )
	Debug_IsEqual( 131, value, value2, "InsertInterface" )

	'=================================================================
	pbsFileSetText( Build$( "#export one,two,three", $CrLf, "#export four, five, six, one, two" ) )
	value = pbsFileFindExports()
	Debug_IsEqual( 132, value, Build$("one",$CrLf,"two",$CrLf,"three",$CrLf,"four",$CrLf,"five",$CrLf,"six" ), "FindExports" )

	'TODO: No unit tests for these yet
	'Declare Function pbsFileBuildDLLInclude()
	'Declare Function pbsFileBuildSLLInclude()
	'Declare Function pbsFileDeclareGetAllInterfaces()
	'Declare Function pbsFileDeclareGetNames( ByVal tp As Long )
	'Declare Sub      pbsFileDeclareScan( Optional ByVal pClear As Long )
End Sub
