Sub SnippetTests()
	Local value, value2 As String
	Local i As Long
	Local decl As TDecl

	pbsKeywordLoad( "pbwin10" )

	Debug_SetGroup("Snippet")
	Debug_Log("")
	Debug_Log("============================================")
	Debug_Log("Snippet")
	Debug_Log("--------------------------------------------")

	Shell( "cmd /c " + RemoveDirectory( "TestSnippet" ), 0 )

	pbsSnippetNew("test")
	pbsSnippetSetText("this is a test")

	pbsSnippetNew("work")
	pbsSnippetSetText("This is work")

	pbsSnippetActivate("test")
	value = pbsSnippetGetText()
	Debug_IsEqual(   1, pbsSnippetGetIndex(), 0, "Index" )
	Debug_IsEqual(   2, value, "this is a test", "SetText" )

	pbsSnippetActivate("work")
	value = pbsSnippetGetText()
	Debug_IsEqual(   3, pbsSnippetGetIndex(), 1, "Index" )
	Debug_IsEqual(   4, value, "This is work", "GetText" )

	value = pbsSnippetNames()
	Debug_IsEqual(   5, value, Build$( "test", $CrLf, "work" ), "Names" )

	pbsSnippetActivate("test")
	Debug_IsEqual(   6, pbsSnippetSizeInBytes(), Len("this is a test"), "SizeInBytes" )

	pbsSnippetActivate("work")
	Debug_IsEqual(   7, pbsSnippetSizeInBytes(), Len("This is work"), "SizeInBytes" )

	Debug_IsEqual(   8, pbsSnippetCount(), 2, "SnippetCount" )
	pbsSnippetSetIndex( 0 )
	Debug_IsEqual(   9, pbsSnippetGetIndex(), 0, "SnippetIndex" )
	Debug_IsEqual(  10, pbsSnippetGetActiveName(), "test", "ActiveName" )

	pbsSnippetSetIndex( 1 )
	Debug_IsEqual(  11, pbsSnippetGetIndex(), 1, "SnippetIndex" )
	Debug_IsEqual(  12, pbsSnippetGetActiveName(), "work", "ActiveName" )

	pbsSnippetClose( "test" )
	Debug_IsEqual(  13, pbsSnippetCount(), 1, "SnippetCount" )
	Debug_IsEqual(  14, pbsSnippetGetIndex(), 0, "SnippetIndex" )
	Debug_IsEqual(  15, pbsSnippetGetActiveName(), "work", "ActiveName" )

	pbsSnippetClose( "work" )
	Debug_IsEqual(  16, pbsSnippetCount(), 0, "SnippetCount" )

	pbsSnippetNew("test")
	pbsSnippetSetText("line1")
	pbsSnippetAddText( "line2" )
	pbsSnippetAddText( "line3" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  17, value, Build$( "line1", $CrLf, "line2", $CrLf, "line3" ), "AddText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetDeleteChars( 0, 0, 0 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  18, value, Build$( "line1", $CrLf, "line2" ), "DeleteChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetDeleteChars( 0, -1, 0 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  19, value, Build$( "line1", $CrLf, "line2" ), "DeleteChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetDeleteChars( -1, 0, 0 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  20, value, Build$( "line1", $CrLf, "line2" ), "DeleteChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetDeleteChars( 0, 0, -1 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  21, value, Build$( "line1", $CrLf, "line2" ), "DeleteChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetDeleteChars( 0, 0, 1 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  22, value, Build$( "ine1", $CrLf, "line2" ), "DeleteChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetDeleteChars( 0, 0, 2 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  23, value, Build$( "ne1", $CrLf, "line2" ), "DeleteChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetDeleteChars( 0, 1, 2 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  24, value, Build$( "le1", $CrLf, "line2" ), "DeleteChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetDeleteChars( 0, 4, 2 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  25, value, Build$( "line", $CrLf, "line2" ), "DeleteChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetDeleteChars( 0, 3, 3 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  26, value, Build$( "lin", $CrLf, "line2" ), "DeleteChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetDeleteChars( 0, 0, 3 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  27, value, Build$( "e1", $CrLf, "line2" ), "DeleteChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetDeleteChars( 2, 0, 1 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  28, value, Build$( "line1", $CrLf, "line2" ), "DeleteChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ) )
	pbsSnippetDeleteText( 1, 0 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  29, value, Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ), "DeleteText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ) )
	pbsSnippetDeleteText( 0, 0 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  30, value, Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ), "DeleteText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ) )
	pbsSnippetDeleteText( -1, 1 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  31, value, Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ), "DeleteText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ) )
	pbsSnippetDeleteText( 4, 1 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  32, value, Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ), "DeleteText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ) )
	pbsSnippetDeleteText( 3, 2 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  33, value, Build$( "line1", $CrLf, "line2", $CrLf, "line3" ), "DeleteText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ) )
	pbsSnippetDeleteText( 0, 1 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  34, value, Build$( "line2", $CrLf, "line3", $CrLf, "line4" ), "DeleteText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ) )
	pbsSnippetDeleteText( 1, 2 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  35, value, Build$( "line1", $CrLf, "line4" ), "DeleteText" )

	pbsProjectSetTabSize(0)
	pbsSnippetSetText( Build$($Tab,$Tab,"line1") )
	pbsSnippetExpandTabs(0)
	value = pbsSnippetGetText()
	Debug_IsEqual(  36, value, Build$($Tab,$Tab,"line1"), "ExpandTabs" )

	pbsSnippetSetText( Build$($Tab,$Tab,"line1") )
	pbsSnippetExpandTabs( 1 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  37, value, Build$("  line1"), "ExpandTabs" )

	pbsSnippetSetText( Build$($Tab,$Tab,"line1") )
	pbsSnippetExpandTabs( 2 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  38, value, Build$("    line1"), "ExpandTabs" )

	pbsSnippetSetText( Build$($Tab,$Tab,"line1") )
	pbsSnippetExpandTabs( 3 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  39, value, Build$("      line1"), "ExpandTabs" )

	pbsSnippetSetText("line1")
	pbsSnippetSetFilename( $BASE_PATH + "TestSnippet\a.bas" )
	value = pbsSnippetGetFilename()
	Debug_IsEqual(  40, value, $BASE_PATH + "TestSnippet\a.bas", "Filename" )

	pbsSnippetSave()
	Debug_IsTrue(  41, IsFile( $BASE_PATH + "TestSnippet\a.bas"), "TestSnippet\a.bas does not exist" )
	pbsSnippetClose( "test" )

	pbsSnippetLoad( $BASE_PATH + "TestSnippet\a.bas" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  42, value, "line1", "Load" )

	pbsSnippetSetText("")
	value = pbsSnippetGetText()
	Debug_IsEqual(  43, value, "", "SetText" )

	pbsSnippetReload()
	value = pbsSnippetGetText()
	Debug_IsEqual(  44, value, "line1", "Reload" )

	value = "bleh"
	pbsSnippetSetText( Build$( "line1", $CrLf, "line2", $CrLf, "line3", $CrLf, "line4" ) )
	value = pbsSnippetGetLine( -1 )
	Debug_IsEqual(  45, value, "", "GetLine" )

	value = pbsSnippetGetLine( 0 )
	Debug_IsEqual(  46, value, "line1", "GetLine" )

	value = pbsSnippetGetLine( 1 )
	Debug_IsEqual(  47, value, "line2", "GetLine" )

	value = pbsSnippetGetLine( 3 )
	Debug_IsEqual(  48, value, "line4", "GetLine" )

	value = pbsSnippetGetLine( 4 )
	Debug_IsEqual(  49, value, "", "GetLine" )

	value = pbsSnippetGetLines( -1, 2 )
	Debug_IsEqual(  50, value, "", "GetLines" )

	value = pbsSnippetGetLines( 0, 1 )
	Debug_IsEqual(  51, value, "line1", "GetLines" )

	value = pbsSnippetGetLines( 1, 1 )
	Debug_IsEqual(  52, value, "line2", "GetLines" )

	value = pbsSnippetGetLines( 3, 1 )
	Debug_IsEqual(  53, value, "line4", "GetLines" )

	value = pbsSnippetGetLines( 4, 1 )
	Debug_IsEqual(  54, value, "", "GetLines" )

	value = pbsSnippetGetLines( 1, 2 )
	Debug_IsEqual(  55, value, Build$("line2", $CrLf, "line3"), "GetLines" )

	pbsSnippetSetText( Build$("Sub Test()",$CrLf,"'This is a comment", $CrLf,"End Sub") )
	pbsSnippetIndent()
	value = pbsSnippetGetText()
	Debug_IsEqual(  56, value, Build$("Sub Test()",$CrLf,$Tab, "'This is a comment", $CrLf, "End Sub"), "Indent" )

	pbsSnippetSetText("line1")
	pbsSnippetInsertChars(-1, 0, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  57, value, "line1", "InsertChars" )

	pbsSnippetSetText("line1")
	pbsSnippetInsertChars(1, 0, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  58, value, "line1", "InsertChars" )

	pbsSnippetSetText("line1")
	pbsSnippetInsertChars(1, 6, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  59, value, "line1", "InsertChars" )

	pbsSnippetSetText("line1")
	pbsSnippetInsertChars(0, 0, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  60, value, "testline1", "InsertChars" )

	pbsSnippetSetText("line1")
	pbsSnippetInsertChars(0, 5, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  61, value, "line1test", "InsertChars" )

	pbsSnippetSetText("line1")
	pbsSnippetInsertChars(0, 2, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  62, value, "litestne1", "InsertChars" )

	pbsSnippetSetText("")
	pbsSnippetInsertClass( 0, "cTest", 0, -1 )
	value = pbsSnippetGetText()
	Debug_IsEqual(  63, value, Build$("Class cTest Common", $CrLf, "End Class", $CrLf ), "Insert Class" )

	pbsSnippetSetText("")
	pbsSnippetInsertClass( 0, "cTest", 0, -1 )
	pbsSnippetInsertInterface( 1, "iTest", "IUnknown", 0 )
	value = pbsSnippetGetText()
	value2 = Build$("Class cTest Common", $CrLf, "  Interface iTest", $CrLf, "    Inherit IUnknown", $CrLf, "  End Interface", $CrLf, "End Class", $CrLf )
	Debug_IsEqual(  64, value, value2, "Insert Class" )

	pbsSnippetSetText("")
	pbsSnippetInsertText( -1, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  65, value, Build$( "" ), "InsertText" )

	pbsSnippetSetText("")
	pbsSnippetInsertText( 2, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  66, value, Build$( "" ), "InsertText" )

	pbsSnippetSetText("")
	pbsSnippetInsertText( 0, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  67, value, Build$( "test", $CrLf ), "InsertText" )

	pbsSnippetSetText("")
	pbsSnippetInsertText( 1, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  68, value, Build$( $CrLf, "test" ), "InsertText" )

	pbsSnippetSetText("line1")
	Debug_IsEqual(  69, pbsSNippetLineCount(), 1, "LineCount" )
	pbsSnippetSetLineCount(2)
	Debug_IsEqual(  70, pbsSNippetLineCount(), 2, "LineCount" )
	Debug_IsEqual(  71, pbsSnippetGetLine(1), "", "LineCount" )
	pbsSnippetSetLineCount(3)
	Debug_IsEqual(  72, pbsSNippetLineCount(), 3, "LineCount" )
	Debug_IsEqual(  73, pbsSnippetGetLine(2), "", "LineCount" )
	pbsSnippetSetLineCount(1)
	Debug_IsEqual(  74, pbsSNippetLineCount(), 1, "LineCount" )
	Debug_IsEqual(  75, pbsSnippetGetLine(0), "line1", "LineCount" )

	pbsSnippetSetText("line1")
	pbsSnippetReplaceChars(-1, 0, 1, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  76, value, "line1", "ReplaceChars" )

	pbsSnippetSetText("line1")
	pbsSnippetReplaceChars(1, 0, 1, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  77, value, "line1", "ReplaceChars" )

	pbsSnippetSetText("line1")
	pbsSnippetReplaceChars(0, -1, 1, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  78, value, "line1", "ReplaceChars" )

	pbsSnippetSetText("line1")
	pbsSnippetReplaceChars(0, 6, 1, "test" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  79, value, "line1", "ReplaceChars" )

	pbsSnippetSetText("line1")
	pbsSnippetReplaceChars(0, 0, 1, "Rh" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  80, value, "Rhine1", "ReplaceChars" )

	pbsSnippetSetText("line1")
	pbsSnippetReplaceChars(0, 4, 2, "2" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  81, value, "line2", "ReplaceChars" )

	pbsSnippetSetText("line1")
	pbsSnippetReplaceChars(0, 5, 2, "2" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  82, value, "line12", "ReplaceChars" )

	pbsSnippetSetText("line1")
	pbsSnippetReplaceChars(0, 1, 2, "os" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  83, value, "lose1", "ReplaceChars" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetReplaceText( -1, 2, "new line" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  84, value,Build$( "line1", $CrLf, "line2" ), "ReplaceText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetReplaceText( 3, 2, "new line" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  85, value,Build$( "line1", $CrLf, "line2" ), "ReplaceText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetReplaceText( 0, 1, "new line" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  86, value,Build$( "new line", $CrLf, "line2" ), "ReplaceText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetReplaceText( 1, 1, "new line" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  87, value,Build$( "line1", $CrLf, "new line" ), "ReplaceText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetReplaceText( 0, 2, "new line" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  88, value,Build$( "new line" ), "ReplaceText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetReplaceText( 1, 0, Build$( "new line 1", $CrLf, "new line 2" ) )
	value = pbsSnippetGetText()
	Debug_IsEqual(  89, value,Build$( "line1", $CrLf, "new line 1", $CrLf, "new line 2", $CrLf, "line2" ), "ReplaceText" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetSetLine( -1, "new line" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  90, value, Build$( "line1", $CrLf, "line2" ), "SetLine" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetSetLine( 2, "new line" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  91, value, Build$( "line1", $CrLf, "line2" ), "SetLine" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetSetLine( 0, "new line" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  92, value, Build$( "new line", $CrLf, "line2" ), "SetLine" )

	pbsSnippetSetText( Build$( "line1", $CrLf, "line2" ) )
	pbsSnippetSetLine( 1, "new line" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  93, value, Build$( "line1", $CrLf, "new line" ), "SetLine" )

	pbsSnippetSetText( Build$( "one One ONE two Two one1 two one", $CrLf, "this is one test" ) )
	pbsSnippetReplaceToken( "one", "three" )
	value = pbsSnippetGetText()
	Debug_IsEqual(  94, value, Build$( "three three three two Two one1 two three", $CrLf, "this is three test" ), "ReplaceToken" )

	pbsSnippetSetText( Build$( $Tab, "  this    is    test", $Tab, "  " ) )
	pbsSnippetTrimWhitespace()
	value = pbsSnippetGetText()
	Debug_IsEqual(  95, value, "this    is    test", "TrimWhitespace" )

	pbsSnippetSetText( Build$( $Tab, "one ", $CrLf, " two",$Tab,$CrLf,"three") )
	pbsSnippetTrimWhitespace()
	value = pbsSnippetGetText()
	Debug_IsEqual(  96, value, Build$("one",$CrLf, "two",$CrLf, "three"), "TrimWhitespace" )


	pbsSnippetLoad( $BASE_PATH + "TestProject\ExportCommon.bas" )
	value = pbsSnippetFindExports()
	Debug_IsEqual(  97, value, Build$("MySub2",$CrLf,"MyFunction2"), "Find Exports" )

	pbsSnippetLoad( $BASE_PATH + "TestProject\testindent.bas" )
	pbsSnippetDeclareScan(-1)
	pbsSnippetAddDebugAliases()
	value = pbsSnippetGetText()
	pbsSnippetLoad( $BASE_PATH + "TestProject\testindentdebugalias.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  98, value, value2, "AddDebugAliases" )

	pbsSnippetLoad( $BASE_PATH + "TestProject\ExportCommon.bas" )
	pbsSnippetDeclareScan(-1)
	value = pbsSnippetBuildDLLInclude("ExportCommon.dll")
	pbsSnippetLoad( $BASE_PATH + "TestProject\ExportCommonDLL.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual(  99, value, value2, "BuildDLL" )

	pbsSnippetLoad( $BASE_PATH + "TestProject\ExportCommon.bas" )
	pbsSnippetDeclareScan(-1)
	value = pbsSnippetBuildSLLInclude("ExportCommon.sll")
	pbsSnippetLoad( $BASE_PATH + "TestProject\ExportCommonSLL.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual( 100, value, value2, "BuildSLL" )

	While pbsSnippetCount()
		pbsSnippetSetIndex(0)
		pbsSnippetClose( pbsSnippetGetActiveName() )
	Wend
	pbsSnippetDeclareClear()
	Debug_IsEqual( 101, pbsSnippetDeclareGetCount(), 0, "DeclareClear" )
	pbsSnippetLoad( $BASE_PATH + "TestProject\ExportCommon.bas" )
	pbsSnippetDeclareScan(0)
	Debug_IsEqual( 102, pbsSnippetDeclareGetCount(), 63, "DeclareClear" )
	pbsSnippetDeclareClear()
	Debug_IsEqual( 103, pbsSnippetDeclareGetCount(), 0, "DeclareClear" )
	pbsSnippetDeclareScan(0)
	Debug_IsEqual( 104, pbsSnippetDeclareGetCount(), 63, "DeclareClear" )

	'=================================================================
	pbsSnippetLoad( $BASE_PATH + "TestProject\exportcommon.bas" )
	pbsSnippetDeclareScan()
	i = pbsSnippetDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	Debug_IsTrue( 105, i>-1, "FindName" )
	i = pbsSnippetDeclareFindName( 0, "iTest", %DeclarationTypes.eInterface )
	Debug_IsTrue( 106, i>-1, "FindName" )
	i = pbsSnippetDeclareFindName( i+1, "iTest", %DeclarationTypes.eInterface )
	Debug_IsTrue( 107, i>-1, "FindName" )

	pbsSnippetClear()

	'=================================================================
	pbsSnippetClear()
	pbsSnippetLoad( $BASE_PATH + "TestProject\exportcommon.bas" )
	pbsSnippetDeclareScan()
	i = pbsSnippetDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	value = pbsSnippetDeclareGetClassInterfaces( i )
	Debug_IsEqual( 108, value, Build$( "iTest", $CrLf, "iTest2", $CrLf, "iTest3" ), "GetClassInterfaces" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetLoad( $BASE_PATH + "TestProject\exportcommon.bas" )
	pbsSnippetDeclareScan()
	i = pbsSnippetDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	value = pbsSnippetDeclareGetClassMethods( i )
	Debug_IsEqual( 109, value, "", "GetClassMethods" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetLoad( $BASE_PATH + "TestProject\exportcommon.bas" )
	pbsSnippetDeclareScan()
	i = pbsSnippetDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	value = pbsSnippetDeclareGetClassOutline( i )
'  clipboard reset
'  clipboard set text value
	pbsSnippetNew("test")
	pbsSnippetLoad( $BASE_PATH + "testProject\exportcommonoutline.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual( 110, value, value2, "GetClassOutline" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetLoad( $BASE_PATH + "TestProject\exportcommon.bas" )
	pbsSnippetDeclareScan()
	i = pbsSnippetDeclareFindName( 0, "MySub4", %DeclarationTypes.eSub )
	value = pbsSnippetDeclareGetDefinition( i )
'  clipboard reset
'  clipboard set text value
	pbsSnippetNew("test")
	pbsSnippetLoad( $BASE_PATH + "testProject\exportcommonMySub4.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual( 111, value, value2, "GetDefinition" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetLoad( $BASE_PATH + "TestProject\exportcommon.bas" )
	pbsSnippetDeclareScan()
	i = pbsSnippetDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	value = pbsSnippetDeclareGetInstanceVariables( i )
'  clipboard reset
'  clipboard set text value
	Debug_IsEqual( 112, value, Build$("a",$CrLf,"b"), "GetInstanceVariables" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetLoad( $BASE_PATH + "TestProject\exportcommon.bas" )
	pbsSnippetDeclareScan(-1)
	value = pbsSnippetDeclareGetNames( %DeclarationTypes.eInterface )
'  Clipboard Reset
'  Clipboard Set Text value
	Debug_IsEqual( 113, value, Build$("iTest",$CrLf,"iTest2", $CrLf, "iTest3"), "GetNames" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetLoad( $BASE_PATH + "TestProject\exportcommon.bas" )
	pbsSnippetDeclareScan(-1)
	i = pbsSnippetDeclareFindName( 0, "cTest", %DeclarationTypes.eClass )
	value = pbsSnippetDeclareGetSignature( i )
	Debug_IsEqual( 114, value, "Class cTest Guid$(""{68EDF2C9-A459-4B4C-B9A4-B44379CB7E9D}"") Common", "GetSignature" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetNew("test")
	pbsSnippetLoad( $BASE_PATH + "TestProject\exportcommon.bas" )
	pbsSnippetDeclareScan(-1)
	i = pbsSnippetDeclareFindName( 0, "iTest", %DeclarationTypes.eInterface )
	Debug_IsEqual( 115, i, 32, "FileNumber" )
	pbsSnippetDeclareGetItem( i, decl )
	Debug_IsEqual( 116, decl.tFileNumber, 0, "FileNumber" )
	Debug_IsEqual( 117, decl.tLineNumber, 91, "LineNumber" )
	Debug_IsEqual( 118, decl.tTokenNumber, 0, "TokenNumber" )
	Debug_IsEqual( 119, decl.tNameIndex, 26, "NameIndex" )
	Debug_IsEqual( 120, decl.tDeclType, 9, "DeclType" )
	Debug_IsEqual( 121, decl.tParent, 29, "Parent" )
	value = pbsSnippetDeclareGetName( decl.tNameIndex )
	Debug_IsEqual( 122, value, "iTest", "GetName" )
	value = pbsSnippetDeclareGetDeclarationName( decl.tDeclType )
	Debug_IsEqual( 123, value, "Interface", "GetName" )

	pbsSnippetDeclareGetItem( decl.tParent, decl )
	Debug_IsEqual( 124, decl.tNameIndex, 25, "NameIndex" )
	value = pbsSnippetDeclareGetName( decl.tNameIndex )
	Debug_IsEqual( 125, value, "cTest", "GetName" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetNew("test")
	pbsSnippetLoad( $BASE_PATH + "TestProject\exportcommon.bas" )
	pbsSnippetDeclareScan(-1)
	value = pbsSnippetGetInterfaceClasses( "iTest" )
	Debug_IsEqual( 126, value, Build$("cTest", $CrLf, "cTest2"), "InterfaceClasses" )

	i = pbsSnippetDeclareFindName( 0, "iTest", %DeclarationTypes.eInterface )
	value = pbsSnippetGetInterfaceRoutines( i )
	Debug_IsEqual( 127, value, Build$("Work", $CrLf, "Test"), "InterfaceRoutines" )

	value = pbsSnippetGetInterfaceStub( i )
'  clipboard reset
'  clipboard set text value
	pbsSnippetNew("test")
	pbsSnippetLoad( $BASE_PATH + "testProject\exportcommonInterfaceStub.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual( 128, value, value2, "GetInterfaceStub" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetNew("test")
	pbsSnippetLoad( $BASE_PATH + "TestProject\exportcommon.bas" )
	pbsSnippetDeclareScan(-1)
	value = pbsSnippetDeclareGetInterfaces()
	Debug_IsEqual( 129, value, Build$("iTest", $CrLf, "iTest2", $CrLf, "iTest3"), "DeclareGetInterfaces" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetNew("test1")
	Call pbsSnippetLoad( $BASE_PATH + "testproject\testindent.bas" )
	pbsSnippetRemoveContinuation()
	pbsSnippetTrimWhitespace()
	pbsSnippetIndent()
	pbsSnippetManageBlankLines()
	value = pbsSnippetGetText()

	pbsSnippetNew("test2")
	pbsSnippetLoad( $BASE_PATH + "testproject\TestIndentManaged.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual( 130, value, value2, "Manage" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetNew("test1")
	Call pbsSnippetLoad( $BASE_PATH + "testproject\testindent.bas" )
	pbsSnippetDeclareScan(-1)
	pbsSnippetAddDebugAliases()
	value = pbsSnippetGetText()
'  Clipboard reset
'  clipboard set text value

	pbsSnippetNew("test2")
	pbsSnippetLoad( $BASE_PATH + "testProject\testindentDebugAlias.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual( 131, value, value2, "DebugAlias" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetNew("test1")
	Call pbsSnippetLoad( $BASE_PATH + "testproject\testindent.bas" )
	pbsSnippetDeclareScan(-1)
	pbsSnippetAddDebugAliases()
	pbsSnippetRemoveAliases()
	value = pbsSnippetGetText()
'  Clipboard reset
'  clipboard set text value
	pbsSnippetClear()
	pbsSnippetNew("test2")
	pbsSnippetLoad( $BASE_PATH + "testProject\testindent.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual( 132, value, value2, "RemoveAlias" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetNew("test1")
	Call pbsSnippetLoad( $BASE_PATH + "testproject\testindent.bas" )
	pbsSnippetDeclareScan(-1)
	value = pbsSnippetFindExports()
	pbsSnippetStandardizeExportAliases(value)
	value = pbsSnippetGetText()
'  Clipboard reset
'  clipboard set text value
	pbsSnippetNew("test2")
	pbsSnippetLoad( $BASE_PATH + "testProject\testindentStdAlias.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual( 133, value, value2, "StandardizeExportAlias" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetNew( "test1" )
	value = Build$( "#Compile Exe", $CrLf, "#Include ""b.inc""", $CrLf, "%ONE=1", $CrLf )
	value += Build$( "' Test routine", $CrLf, "Sub Test()", $CrLf, $Tab, "? ""Hello"" + Str$(%one)", $CrLf, "End Sub" )
	pbsSnippetSetText( value )
	'                                                          single
	'                                tab  Keyword casing         case  mono color
	value = pbsSnippetToHtml( "c.bas", 2, %KeywordCase.Original,   -1,   -1,   -1 )
	Clipboard Reset
	Clipboard Set Text value
	pbsSnippetNew("test2")
	pbsSnippetLoad( $BASE_PATH + "testProject\c2.html" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual( 134, value, value2, "ToHtml" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetNew("test1")
	value = Build$( "#Compile Exe", $CrLf, "#Include ""b.inc""", $CrLf, "%ONE=1", $CrLf )
	value += Build$( "' Test routine", $CrLf, "Sub Test()", $CrLf, $Tab, "? ""Hello"" + Str$(%one)", $CrLf, "End Sub" )
	pbsSnippetSetText( value )
	'                                                             single
	'                                   tab  Keyword casing         case  mono color
	value = pbsSnippetToBBCode( "c.bas",  2, %KeywordCase.Original,   -1,   -1,   -1 )
'  Clipboard Reset
'  Clipboard Set Text value
	pbsSnippetNew("test2")
	pbsSnippetLoad( $BASE_PATH + "testProject\c2.bbcode" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual( 135, value, value2, "ToBBCode" )

	'=================================================================
	pbsSnippetClear()
	pbsSnippetNew("test1")
	value = Build$( "#Compile Exe", $CrLf, "#Include ""b.inc""", $CrLf, "%ONE=1", $CrLf )
	value += Build$( "' Test routine", $CrLf, "Sub Test()", $CrLf, $Tab, "? ""Hello"" + Str$(%one)", $CrLf, "End Sub" )
	pbsSnippetSetText( value )
	'                                           single
	'                    tab  Keyword casing      case
	pbsSnippetToCasedText(  2, %KeywordCase.Mixed,   -1 )
	value = pbsSnippetGetText()
'  Clipboard Reset
'  Clipboard Set Text value
	pbsSnippetNew("test2")
	pbsSnippetLoad( $BASE_PATH + "testProject\c2Std.bas" )
	value2 = pbsSnippetGetText()
	Debug_IsEqual( 136, value, value2, "ToStandard" )

	'Declare Sub      pbsSnippetDeclareSetSnippet( snippetName As String )
	'Declare Function pbsSnippetGetInterfaceDeclaration( ByVal index As Long, constants As String )
End Sub
